Encrypt ASP files - general information

Protecting ASP files - General information

  • What's the difference between the Standard and Enhanced ASP encryption?
  • Encrypting client-side html / script code
  • Encrypting includes
  • ASP encryption limitations and troubleshooting
  • Support
  • Additional information about the Standard ASP encryption.

What's the difference between the Standard and Enhanced ASP encryption?
HTML Guardian provides two encryption methods for .ASP files - Standard and Enhanced.
You can choose which one to use from the General Settings configuration window.

The table below shows all the differences between the Standard and Enhanced ASP encryption.
[ Note: HTML Guardian treats includes (files included in .asp files with the <!--# include file ..--> or <!--# include virtual ..--> statements) in a slightly different way than other asp files, as explained here. That's why the features available for includes are separated from the features available for files that are not used as includes) ]

ASP Encryption Type: | Standard | Enhanced
Features available: |  |
ASP source encryption | Partial - by default, only the server-side parts of the code (enclosed within <% ... %>) are encrypted. Client-side html & script code remains un-encrypted. It is possible to encrypt predefined pieces of pure client-side code - this requires small modifications of the original asp source. | Full - the source code is encrypted entirely - no portion of the code remains unencrypted. Modification of the original source code is not needed.
Using the additional protection options for .asp files | Yes * | Yes *
Encryption of includes | Partial - only the server-side parts of the code (enclosed within <% ... %>) are encrypted. Client-side html & script code remains un-encrypted. | Full - includes are encrypted entirely - no portion of the code remains unencrypted.
Using the additional protection options for includes | No | Yes **
Encrypting ASP server response (the code that the server generates and sends back to the requesting browser) | It is possible to encrypt predefined pieces of pure client-side code in the server's response - this requires small modifications to the original asp source. The parts of the code dynamically generated by the server can not be encrypted in the server's response. | All the client-side code will be encrypted in the server's response. Modification of the original source code is not needed. The parts of the code dynamically generated by the server can not be encrypted in the server's response.
Encrypting ASP server response for includes | No | Yes
ASP code compression | No | Yes ***

Note that the Enhanced ASP encryption is fully functional only in the Enterprise edition of HTML Guardian. A complete comparison between HTML Guardian Personal, Professional and Enterprise editions you can see here.

* The password protection option is not available. All other protection options - disable right click, printing etc. are available.
If any additional protection option is used, the 'Don't allow offline use / Domain Lock' protection will be automatically applied even if the box is not checked - this means the server's response can't be saved as .html file for later offline viewing. But if no additional protection options are specified, 'Don't allow offline use / Domain Lock' will not be automatically applied.
A very important consequence of the above is that if you selected to use Domain Lock instead of Don't allow offline use (in the General Settings configuration window), you will not be able to test encrypted asp files through a local server, because the code generated by the server will be locked to your domain - this applies both to Standard and Enhanced ASP encryption.

*** Compression of asp files is automatically done before the encryption. It is not possible only to compress the asp source code without encrypting it.

Go back

Encrypting client-side html / script code

If Enhanced encryption is used, all the client-side code in the asp source will be encrypted entirely.
To encrypt the client-side code in the response which the server generates and sends back to the browser (this is what your visitors will see after clicking View-->Source), check the 'Encrypt server response' box in the ASP section of the the General Settings window.
Note that the code dynamically generated by the server will not be encrypted in the response.

Note that this feature works in a different way in Standard encryption mode.

Go back

Encrypting includes

It is a common practice to use includes if you want to insert the same piece of code in many files. Normally you can include any .asp file in any other.
But to ensure proper encryption, HTML Guardian needs to know whether the asp file being encrypted will be used as an include in other files or not.
To mark an .asp file as an include, insert this comment somewhere in it (like at the end of the file):
<!--hgaspinclude -->
ASP files encrypted as includes can't be used as standalone files. ASP files encrypted as standalone files can't be used as includes. If you have a file used both as a standalone and as an include, you should make a second copy of it - then encrypt one copy as an include(with the above comment tag inserted) and the other as a standalone file.
Files with .inc extension are always treated as includes, you do not have to insert this tag in them.
Files with extensions different than .asp and .inc will not be recognized as asp files and will not be encrypted.

If you check the 'Auto-import ASP includes' box in the 'General settings ' window, there is no need to put the above comment tag in the include files.

Go back

ASP encryption limitations and troubleshooting

Only encrypted .asp files can use encrypted includes. A non-encrypted .asp file that uses an encrypted include will most likely not work. An encrypted .asp file may use either encrypted or non-encrypted includes.

HTML Guardian needs to know whether the asp file being encrypted will be used as an include in other files or not.
To mark an .asp file as an include, insert this comment somewhere in it (like at the end of the file):
<!--hgaspinclude -->
Files encrypted without this tag being present in the original source and then used as includes in other files will not work.

If you are using the Standard encryption method, please read the Standard ASP encryption section of the Help. There are some additional requirements if the Standard method is used.

Image Guardian will not protect images used in asp files.

** Please do not use the same additional protection options for the main asp file and for the include(s) it uses - this may cause problems. If for example the file main.asp is protected with the 'Disable page printing' option, any includes main.asp uses should be encrypted without 'Disable page printing' option. If any of the includes is protected with this option, main.asp and the rest of the includes it uses should be encrypted without it.

If you have configured HTML Guardian to use Domain Lock instead of Don't allow offline use protection, you will not be able to test encrypted asp files on your PC (through a local http server).

Go back

Support
In case of any problems in regard to asp files encryption you are always welcome to contact our support team.
To be able to solve any problem, we need to reproduce it first. So please *zip*! and send us all the files(unencrypted) needed to reproduce the problem.

Please DO NOT send us files which we can't test, like for example asp files which connect to databases, or require whatever that might not be present on another computer.

Please only send us files which are completely ready for testing. All the relative paths used in the files should be correct, there should not be <!--include virtual.... --> statements, references to files which are not available, or anything else that may cause problems when the files are tested on another computer. We strongly recommend that you test the files on another computer yourself before sending them to us, to be sure the original files will work correctly when we test them - without that, we will not be able to find why the encrypted files cause problems and help you.

Please DO NOT send us URL's where the problematic files can be viewed online - send us the files instead.

Please DO NOT send us encrypted files(unless we request them) - we can't do anything with them. We can only view them as everybody else can, but we can't analyze the encrypted source. We can't use encrypted files for debugging and identifying your problem.

Go back
Go back Next

© 1997-2003, ProtWare Inc. All rights reserved.


Protecting ASP files [Standard ASP encryption]

  • General information
  • Encrypting client-side html / script code
  • Encrypting includes
  • Using the additional encryption options for .ASP files
  • What "Not Encrypted" message means?
General information [Standard ASP encryption]

By default, HTML Guardian will only encrypt the server-side parts of the code for .asp files.
That's the code enclosed within <% ...... %> delimiters, and it's usually the most important part of the asp file.
By default, the rest of the code (client-side code) will remain unencrypted, and the code visitors see in their browsers will be unencrypted.
The following is also possible:
You can encrypt client-side html and script code contained in ASP files.
You can encrypt includes, and you can include an encrypted file in another encrypted file
You can use all the additional protection options for .asp files (except password protection).
But HTML Guardian will not do this automatically.
Your files need to be prepared for that or to comply with some requirements. Please carefully read the sections below.

Encrypting client-side html / script code [Standard ASP encryption]

You can encrypt any portion of the client-side code in an .asp file (html and / or client-side scripts), but this will not be done automatically. You have to specify which parts of the client-side code to be encrypted by enclosing them within these html comment tags (case sensitive):

<!--hgasp_s -->
... here comes the client-side code you want to be encrypted ...
<!--hgasp_e -->

The code enclosed within these comment tags should be a pure client-side code. It should not contain any server-side code (<% .... %>) or commands (like #INCLUDE) - otherwise client-side code encryption will be aborted (in such case a new entry will be added to the Error Log. No visual alerts will be displayed).
Client-side code can't be encrypted for includes.

There are two methods to encrypt client-side code:

client-side code is encrypted only in the ASP source - in this case the client-side code will be encrypted in the ASP source, but will not be encrypted in the response ASP server generates and sends back to the browser. If the visitors click View-->Source in their browsers, the entire source code they will see will be unencrypted.
client-side code is encrypted both in the ASP source and in the response ASP server generates and sends back to the browser. If the visitors click View-->Source in their browsers, the client-side code from the ASP file will be encrypted. Note that the code dynamically generated by the server will appear unencrypted.

You can toggle between the two methods by pressing CTRL + ALT + A keys. Press F4 at any time to see the current setting. You can permanently change this settings from the General Settings window.
If you want to encrypt only client-side scripts, you may just put them in a separate .js file and encrypt it.
Go back

Encrypting includes [Standard ASP encryption]

It is a common practice to use includes if you want to insert the same piece of code in many files. Normally you can include any .asp file in any other.
But to ensure proper encryption, HTML Guardian needs to know whether the asp file being encrypted will be used as an include in other files or not.
To mark an .asp file as an include, insert this comment somewhere in it (like at the end of the file):
<!--hgaspinclude -->
If you check the 'Auto-import ASP includes' box in the 'General settings ' window, there is no need to put the above comment tag in the include files.

ASP files encrypted as includes can't be used as standalone files. ASP files encrypted as standalone files can't be used as includes. If you have a file used both as a standalone and as an include, you should make a second copy of it - then encrypt one copy as an include(with the above comment tag inserted) and the other as a standalone file.
Files with .inc extension are always treated as includes, you do not have to insert this tag in them.

Client-side code can't be encrypted for includes.
Additional protection options can't be used for includes.
Note: Only encrypted .asp files can use encrypted includes. A non-encrypted .asp file that uses an encrypted include will most likely not work. An encrypted .asp file may use encrypted or non-encrypted includes.

Go back

Using the additional encryption options for .ASP files [Standard ASP encryption]

You can use all additional protection options that HTML Guardian provides for .asp files, except the password protection option. The following should be observed:

- The .asp file should have <HEAD> and </HEAD> tags.
These tags should NOT be a part of the server-side code (they should NOT be between <% .... %> delimiters).
These tags should NOT be a part of code marked for client-side code encryption (they should NOT be between <!--hgasp_s --> .... <!--hgasp_e --> tags).

Below are some examples:

Incorrect | Incorrect | Correct
..... <% .......... Response.Write("<HEAD>") .......... %> ....... | ..... <!--hgasp_s --> <HEAD> ........... </HEAD> <!--hgasp_e --> ..... | ...... <HEAD> <!--hgasp_s --> ..some client-side code.. <!--hgasp_e --> <% ..some server-side code.. %> <!--hgasp_s --> ..some client-side code.. <!--hgasp_e --> </HEAD> ........
Here the <HEAD> tag is a part of the server-side code | Here the <HEAD> and </HEAD> tags are marked for client-side code encryption

- The opening <HEAD> tag should look this way: <HEAD> (case doesn't matter)
There should be no additional information in it, like <HEAD id="abc">. In case you need to add something to the opening <HEAD> tag, you should do this after the encryption.

- if your .asp file does not start with @LANGUAGE directive, like
<%@ LANGUAGE = VBScript %> or <%@ LANGUAGE = JScript %>
, HTML Guardian will assume the scripting language is VBScript. In some rare cases the asp server where your site is hosted may be configured to use JScript as a default scripting language. If this is the case, you should insert <%@ LANGUAGE = JScript %> at the very beginning of each .asp file you want to protect (this should be the first line of code).

Additional protection options can't be used for includes.

If you have configured HTML Guardian to use Domain Lock instead of Don't allow offline use protection, you will not be able to test encrypted asp files on your PC (through a local http server).
Go back

What "Not Encrypted" message means?
This is not an error message. In HTML Guardian Personal edition there is a limit for the file size of the .asp files that can be encrypted (when using the Standard ASP encryption). If the file being encrypted exceeds this limit, the 'Not encrypted' message appears. In Professional & Enterprise edition this limitation is removed.
Go back


HTML Guardian Help

HTML Guardian 6.x Help


Purchase HTML Guardian

Purchase HTML Guardian Professional or Enterprise Edition

Click one of the links below to open the HTML Guardian Professional or Enterprise online order form in the language you prefer.

HTML Guardian Professional order form in English | German | Portuguese | Spanish | Italian | French

HTML Guardian Enterprise order form in English | German | Portuguese | Spanish | Italian | French

You can also purchase HTML Guardian Professional edition or HTML Guardian Enterprise edition by visiting our website and following the 'Buy' link, or by clicking 'Purchase HTML Guardian Professional online' or 'Purchase HTML Guardian Enterprise online' under the 'Help' menu.
If you have any questions about purchasing HTML Guardian Professional or Enterprise, please direct them to sales@protware.com

What is the difference between HTML Guardian Professional and Enterprise ?

A complete comparison between HTML Guardian Personal, Professional and Enterprise editions you can see here.


HTML Guardian command line reference

Using the File List Manager

File List Manager is a tool for easy automation of common encryption tasks. If you need to encrypt periodically the same set of files, you can add them to an encryption file list. Then you can encrypt all files in the list with a few clicks!
You can specify a different set of protection options for each file in the list.
All options available in the main HTML Guardian window can be set from the File List Manager for each file individually (with a few exceptions ).

To open the File List Manager, click 'File List Manager' under the 'Tools' menu, or press Ctrl + L.
If you are creating a new list, select a Default Save Location first from the four available options. This is only for convenience, the folder and the filename for saving each file can be changed later.
Default Save Location options are:

- Same folder, same name - encrypted file will overwrite the original file. Use this option only if you have backups of the original files.

- Same folder, add ... to the filename - will change the filename of the encrypted file. If for example you enter _E in the box, the encrypted version of index.htm will be saved as index_E.htm in the same folder.

- ... subfolder of the file folder - will create a subfolder with the specified name in the folder of the original file and will save the encrypted file there, with the same filename. If for example you enter Encrypted in the box, the encrypted version of C:\Test\index.htm will be saved as C:\Test\Encrypted\index.htm

- Put all encrypted files from this list in one folder - checking this option will open a 'Select Folder' dialog. All encrypted files will be saved in the selected folder with the same filenames.

Click the Add File(s) button to add files to the list.
Hold down Ctrl or Shift keys to add multiple files at once.
New files are added at the top of the list.
After adding one or more files, you can change the Default Save Location option - new files will be then added to the list using the new Default Save Location specified.
When you add all the files you want to the list, you can change the Save Location and the protection options for each file by double clicking the appropriate cell.
When ready, save the list. Lists are saved with .hgl extension.

If you can't see the whole text in some cell, just click it once - the full text will be displayed in the status bar at the bottom of the File List Manager window.

To open an existing file list for editing and/or encryption, click the Open List button.
To remove a file from the list, select it (click once inside any cell from the same row) and click the Remove File button.

Important note: On some systems the Add file(s) and/or Remove File buttons may not work correctly (for example you may choose to remove the second file from the list but the last one is removed instead). This is caused by bugs in certain versions of some Windows system files.
If such problem appears, select a cell(just click it once) from the first column (under the 'File to Encrypt) before clicking Add file(s) or Remove File. This is very rare problem, and usually installing the latest Windows service pack fixes it.

Options not supported in File List Manager :

Only compress code and Disable Syntax check options are not supported (almost all HTML Guardian syntax checkers and code validation tools are disabled when a file list is encrypted).
Scramble Non-ASCII characters option can't be set for each file individually. It is possible to use it, but for all files in the list. To do this, minimize the File List Manager window and check the Scramble Non-ASCII characters box in the main HTML Guardian window, then restore the File List Manager window and click the Encrypt List button. This setting is not stored in the file lists - you need to check this box each time before encrypting a file list if you want to use this option.

All other options are fully supported. You can add files containing partial encryption tags to the file lists.

Some important notes :

- all the settings specified in the currently loaded profile will be applied to the files in the list, except those specified in the Default Settings tab. If no profile is loaded, the default HTML Guardian settings will be applied for all the options that can't be configured from the File List Manager.

- if the destination file (in the Save Encrypted File As column) exists, it will be overwritten without prompt.

- almost all HTML Guardian syntax checkers and code validation tools are disabled when a file list is encrypted. If you have problems with some encrypted file, encrypt the original again individually, not from a file list.

- File List Manager does not validate the settings you enter, it will accept any setting for each file type. However all restrictions are valid when files from the list are encrypted, which means some protection options may not be applied for some files even if they are specified in the file list. For example no 'Disable Right click' or 'Disable Text selection' protection will be added to frameset files, even if they are specified in the file list.

HTML Guardian command line reference

File List Manager is intended to replace the command line usage of HTML Guardian. However the full command line support is still available, you can use this feature to control HTML Guardian from other applications like your own VisualBasic, C etc. programs.

HTML Guardian command line syntax has the following structure :

htmlg.exe inputfile, outputfile, [switch1], [switch2]...... Note that comma ( , ) is used to separate the options.

htmlg.exe - required. The name of the main HTML Guardian executable. If you call htmlg.exe from another folder(not from the folder where it resides), you should use the full path to it like C:\Program Files\HTML Guardian\htmlg.exe
inputfile - required. The full path to the file you want to encrypt, like C:\MySite\index.htm
outputfile - required. The path for saving the encrypted inputfile, including filename, like C:\MySite\Encrypted\index.htm

Inputfile and outputfile parameters should be absolute paths. Relative paths can't be used.

Important: outputfile parameter must be a valid path, it should point to an existing folder. In the example above, the folder C:\MySite\Encrypted\ must exist. If the outputfile parameter is invalid, the file will not be encrypted, it will be skipped.
If inputfile and outputfile parameters are the same, HTML Guardian will overwrite the original file with the encrypted file without prompting! Please be careful!

All switches are optional, and are described below:

IE5 - use alternative encryption method(for IE 5+ only). If omitted, the default method(for all browsers) will be used.
R - disable right click
L - don't show links in status bar
T - disable text selection
O - prohibit offline use
N - disable page printing
C - disable clipboard & print screen (this option will only work for IE 5+ browsers)
M - encrypt Meta tags.
P@password@redirection - set the password for the page and a redirection URL in case of incorrect password.
password - the password that the visitor must enter to see the page.
possible values for the redirection part are:
blank - will display a blank page.
back - will turn the visitor back to the previous page visited.
any valid URL, like http://www.protware.com - will redirect the visitor to this url in case of incorrect password.
F@referrer@redirection - set the scope of URL's allowed to link this page, and a redirection URL in case the page is linked from another place.
referrer - a string that identifies the sites allowed to link this page. Normally that would be your domain name, like protware or protware.com - in this case the protected file can be linked only from within your domain. You may also include a filename here, like http://www.protware.com/features.htm, or just protware.com/features.htm - in this case, the protected file can be linked from the specified file only.
possible values for the redirection part are:
blank - will display a blank page.
any valid URL, like http://www.protware.com - will redirect the visitor to this url in case of incorrect password.

Batch file example:

htmlg.exe C:\Test\index.htm, C:\Test\Encrypted\index.htm, R, L, O, P@123@back
htmlg.exe C:\MySite\test.htm, C:\Test\test.htm, IE5, R, T, F@protware@blank

Copy the two lines above, paste them in any text editor, and save the file in HTML Guardian's installation folder with a .bat extension, like filelist1.bat. Then just double click this file to start encryption.

Some settings are not available in command line mode, for example you can't change the encryption method for 'All' browsers - all files will be encrypted using the encryption method currently set as default.


Contact ProtWare

Contact information:

Technical support: support@protware.com

Sales department: sales@protware.com

Development: dev@protware.com

Beta testing: betatest@protware.com

Webmaster: webmaster@protware.com


Style sheets protection

Protecting Style Sheets (.css) files

You can protect style sheet (.css) files with HTML Guardian, but this requires a small modification to be made in each html file that uses a protected style sheet. HTML Guardian converts style sheets into encrypted script files - if you encrypt let's say myStyle.css file, the result will be saved as myStyle.js

In each html file that uses myStyle.css, there should be a reference to it like
<link rel="stylesheet" href="myStyle.css" type="text/css">
- you should remove this reference and put a reference to the encrypted myStyle.js instead like this
<script src = "myStyle.js"></script>
So if you want to use an encrypted .css file together with encrypted html files, you should first encrypt the .css, then modify and encrypt the html files.

You can encrypt .css files only if you select them with the 'Select file' button.
When you encrypt folders or sites defined in the Site Manager, .css files will not be encrypted.

If you want to use an encrypted .css file when you encrypt a folder or a site, you should proceed as follows:
- encrypt the .css file
- replace the reference to the .css file with a reference to the encrypted .js file created by HTML Guardian(as explained above) in each html file that uses the style sheet.
- encrypt the folder (site).


Encrypt PHP source, HTML, JavaScript. Protect links & images

Encrypt PHP source code

PHP encryption is a new, still experimental feature of HTML Guardian.
Please note that at this time we do not provide technical support for it - this means we may not be able to solve the problems you experience when you encrypt php files.
However, please report all problems to our support team - you may or may not receive a reply, but the problem will be examined and the CodeAnalyzer ™ engine knowledge base will be updated. Reporting any problem you experience will help us a lot to improve php encryption in the next releases of the program.

Please be aware of the following limitations in php encryption:

- only the client-side code will be encrypted . The php code (enclosed within <? .... ?> delimiters) will not be. However, this code is not visible for the visitors of your site, it can't be seen if a visitor clicks View-->Source. The code generated by the php scripts will not be encrypted.

- HTML Guardian will only recognize the .php file extension. Files with .phtml, .php3 etc. extensions will not be recognized as php files. To encrypt such files, you'll have to change their extension to .php first. After the encryption, you may rename the encrypted file to restore the original extension.

- HTML Guardian will only recognize <? ...... ?> delimiters as php delimiters. The php code should be enclosed within <?PHP .... ?> or just <? ...... ?>.
If your php code is enclosed within asp-style tags <% .... %> , the encrypted file will most likely not work.

- Image Guardian can't protect images referenced inside php parts of the code <? ...... ?>. Only the images referenced in the client-side code can be protected.

PHP encryption support will be improved in the next versions of HTML Guardian.
Please inform us for any problems you have when you encrypt php files.

Next: Beta Testing


HTML Guardian FAQ

HTML Guardian Frequently asked questions:

For image protection issues, see Image Guardian FAQ

Note:
Let's clarify something first: when you open some web page, everything you see in your browser is already somewhere on your hard disk. This means the html file itself and all external files referenced in it, such as script files(.js, .vbs), images, java applets, flash animations, sound files, style sheets(.css) etc.

Protection issues:

  • Why all the experts recommend HTML Guardian for web site protection? There are so many programs that look similar.
  • Can I protect my html code and scripts?
  • Can I protect my images?
  • Can I disable the Image Toolbar in Internet Explorer 6?
  • Can I protect java applets?
  • Can I protect my links from stealing and leeching?
  • Can I prohibit copying text from my pages?
  • Can I prohibit printing of my pages?
  • Can I encrypt only some parts of the code?
  • Can I encrypt ASP files?
  • Can I encrypt cascading style sheets(.css) files?
  • Can I encrypt PHP files?
  • Can I protect flash animations?
  • Which protection method I should use? What's the difference?
  • Can I password protect a page? How secure is this?
  • What will be encrypted?
  • Do I need to use all protection options available? What's the recommended set of options?
  • Can I encrypt HTML formatted email messages?
  • I don't want my site to be visited with certain browsers. Is it possible to deny access to my site if it is visited with certain browsers?
  • Which file types I can protect with HTML Guardian?

Technical issues:

  • How to remove the banner from encrypted files?
  • Will encrypted files be displayed correctly in all browsers?
  • Can I encrypt files created on Macintosh computers?
  • Will encryption increase the size of the protected file?
  • How to encrypt multiple files at once?
  • The encrypted file loads slow!
  • The encrypted file doesn't work!
  • Password protected file is displayed even if I enter a wrong password.
  • Referrer check doesn't work.
  • You said HTML Guardian will dramatically increase visits to my site, but there is no difference at all.
  • I lost my original files! Can you help me recover them?
  • Where is CodeAnalyzer? How to access it?
  • I see an error message "Component 'xxxxx.yyy' or one of its dependencies not correctly registered: a file is missing or invalid " when I start HTML Guardian or when I try to use some feature. What to do?
  • What HTML Editor I should use to create my pages? What 'HTML Guardian compatible HTML Editor' means?
  • Virus scanners or internet security programs display alerts about HTML Guardian. What should I do?
  • Encrypted files don't work after I upload them to PayPal
  • HTML Guardian crashes when started on WindowsXP
  • HTML Guardian works slow

Other issues:

  • What's the difference between HTML Guardian Personal, Professional, Enterprise and Server edition?
  • Do you offer a money back guarantee?
  • What is your upgrade policy? If I purchase HTML Guardian Professional or Enterprise, do I have to pay for the new versions you release ?
  • Do you plan to release HTML Guardian for Linux and Mac?

Privacy policy:

  • ProtWare Inc. privacy policy

Protection issues:

Why all the experts recommend HTML Guardian for web site protection? There are so many programs that look similar.
Ask the experts :).
There are really many programs that seem similar to HTML Guardian - but only at first sight.
Actually there are a lot of features unique to HTML Guardian and not available in any other program. The most important of them are:
- strongest protection - HTML Guardian is worldwide recognized as the most secure website protection utility, even all our competitors acknowledge that. Files protected with most of the other similar programs can be deprotected in minutes even by not so knowledgeable users. Files protected with HTML Guardian are known to be the best secured ones.
- error free encryption - HTML Guardian's Code Analyzer ™ engine is unique , there is no similar tool in any other program. It debugs the encrypted code in all major browsers and ensures error-free rendering of the encrypted file in all browsers installed on any operating system. Files protected with other programs very often cause browser or even system crashes - you may have no idea of those problems if the files work OK on your PC, but the result of such problems could be that a lot of people will never visit your site again. Of course HTML Guardian is not bug-free, but Code Analyzer™, encryption and debugging engines knowledge base is updated regularly.
- full web site protection - you can protect almost all types of web files - html, shtml, asp, javascript, vbscript, style sheets, images etc. - no other program can do this. Most of them can only protect html files, with questionable results and / or a very weak degree of protection.
- integrated web site image protection - not available in any other product. No other program ensures full image protection. Actually no other program ensures whatever image protection at all.
- ultra-strong password protection - not available in any other product. Many similar programs claim they provide secure password protection, but in all cases we tested it was actually very weak and it took several minutes for our cryptography experts to crack it. In fact, in most cases experts were not needed at all - a very basic knowledge on Javascript was enough. Almost all similar programs use elementary algorithms for password protection, most often taken from websites that provide script examples. HTML Guardian provides extremely secure, up to 384 bit key password protection - no other program ensures such level of security, or even a closer level of security.
- asp source code encryption - not available in any other product. There is no other tool available on the market that can protect asp source code in any way. HTML Guardian can also protect client-side code in the asp source.
- standardization - HTML Guardian is already a web standard for intellectual property protection. This may not seem very important for individual users at this time, but will become more and more important in the near future.
- fast support and bug-fixing- all user - reported bugs are usually fixed within 72 hours. A bug-fixed version is available for download for all users immediately after it is released via the auto-update utility.
- auto-update via the web - check for updates, download and install them automatically from the internet. All the updates we release are immediately available for registered users for free.
- full command-line support - automate HTML Guardian and send commands to it from your own C, C++, Visual Basic etc programs. This feature is used from many software developers.
- advanced batch file processing - encrypt file lists or entire web sites with protection options specified for each file individually. The Site Manager tool allows you to customize the layout of the browser in which the protected site is opened and optionally remove the Address(URL) bar, Menu bar, Toolbar, Status bar. Not available in any other product.
- powerful partial encryption capabilities - in case for some reason you do not want to encrypt the entire file, you can define exactly which parts of the code to be encrypted (or which parts to remain unencrypted). Not available in any other product.
- more than 30 different encryption algorithms - when protecting your files, HTML Guardian uses more than 30 different algorithms. But you do not have to hesitate which one to choose - after examining the source code, the CodeAnalyzer™ engine automatically selects the one that ensures maximum security and best performance.

All the above is just a brief summary of the most important HTML Guardian advantages. There are many others not listed here. Please download HTML Guardian and test it yourself.
Back to Top

Can I protect my html code and scripts?
Yes. If you encrypt them, no portion of the code can be reused in another file. It is not possible to identify and extract a part of the code which corresponds to a certain part of the document's visual layout. For example, if you have a table in your page, it is not possible to determine what part of the encrypted code corresponds to that table. Editing encrypted files with HTML editor or in any other way is not possible. Changing even a single character will make the file non-working.
Back to Top

Can I protect my images?
Yes. If you choose to disable the right click in the encrypted file, visitors will not be able to right click and select 'Save image..' from the context menu (this will also disable the IE6 Image Toolbar). If you choose 'Save As' from the 'File' menu in Internet explorer, it will save the html file and all images and other files referenced in it. But if the file is encrypted, images and other files will not be saved.
You may also use the 'Disable Clipboard & Print Screen' option to prevent taking screenshots of your pages.
However, when someone browses your site, all images referenced in html files are first downloaded and then displayed. So all your images are somewhere on visitor's hard drive. They are not stored under their original names, but are still there and someone can find them, although that's not so easy and most internet users don't know how to do that.
For a complete image protection , you have to use Image Guardian - HTML Guardian add-on especially designed for image protection. Note that Image Guardian is fully functional only in HTML Guardian Enterprise Edition.
A complete comparison between HTML Guardian Personal, Professional and Enterprise editions you can see here.
Back to Top

Can I disable the Image Toolbar in Internet Explorer 6?
Yes. Selecting 'Disable right click' feature will also disable the Image Toolbar in Internet Explorer 6. But for a complete image protection , you have to use Image Guardian.
Back to Top

Can I protect java applets?
You can not protect the java files(.class, .jar, .cab, .zip) with HTML Guardian.
But you don't have to worry about that. Almost all applets has to be configured to work. This is done through parameter tags inside the <applet> tag, i.e. applet configuration is a part of the html code. The applet files are useless if you don't know what parameters to use and what values are acceptable for them, but this info can't be obtained from the encrypted html file. So your applets are safe.
There are also many applets you have to pay for. They usually need some kind of registration number to work, and this number is provided as a parameter inside the <applet> tag - anyone can see it, get the applet files and use them with no problems at all. If you encrypt html files which use the applet, this will be impossible.
Back to Top

Can I protect my links from stealing and leeching?
Yes. You have to check the 'Disable right click' and 'Don't show links in status bar' boxes. This way links can't be copied by using the right click context menu, and link targets will not be visible in browser's status bar when the mouse is over a link. Be careful when using the 'Don't show links in status bar' option - it will suppress your custom status bar messages, if any.
HTML Guardian will also make impossible link leeching. Many programs(such as popular download managers GoZilla and GetRight) can leech all links from a html document. If for example you have a picture gallery on your site, it's a one minute job to leech the links to all your images with such program. Then someone can directly use your links in another site, this way not only stealing them, but also generating a traffic to your site which you may have to pay.
So HTML Guardian will not only make impossible stealing and leeching of your links, but may also save you money in case you pay for the traffic.
Back to Top

Can I prohibit copying text from my pages?
Yes. Check the 'Disable text selection' box. This will make impossible text to be selected and copied by dragging the mouse, pressing Ctrl+A or clicking 'Select All' either in browser's Edit menu or in the right click context menu.
Back to Top

Can I prohibit printing of my pages?
Yes. Check the 'Disable page printing' box.
Note: This will not actually 'disable' printing. If someone tries to print a protected html file, only blank pages will be printed.
Back to Top

Can I encrypt only some parts of the code?
Yes. You need to use the partial encryption option. Since this option is not available in HTML Guardian's main window, many users get confused. HTML Guardian can encrypt either entire file, or only desired parts of it.
If you want to encrypt a part of the code, you have to enclose it within these html comment tags(case sensitive):

<!--htmlgstart -->
... here comes the part of the code you want to encrypt
<!--htmlgstop -->

If you want some part of the code to remain unencrypted, you have to enclose it within these html comment tags(case sensitive):

<!--htmlgskipstart -->
... here comes the part of the code you do not want to encrypt
<!--htmlgskipstop -->

Note: There should be no empty space after <!-- and there should be one empty space before --> - otherwise the tags will not be recognized.
If HTML Guardian founds these tags in the file to be encrypted, it will automatically switch to partial encryption mode, otherwise it will encrypt the entire file. Partial encryption is only possible for html files, and not for script, frameset, .shtml or .asp files. You can encrypt or leave unencrypted as many parts of the code as you wish, but you can't mix both partial encryption methods in one file.
Partial encryption can be very useful sometimes. This way you can edit the unencrypted code without having to reencrypt the file afterwards. Also you can use it for big html files, like 100K or bigger - decoding the encrypted code can be slow for big files if your visitors use slow processors, like 486.
You can also use the partial encryption to skip problematic parts of the code and leave them unencrypted. For example some webpage visit counters code may cause problems - just mark this code to be skipped.
Parts of the code selected for encryption or for skipping should not contain unclosed tags, otherwise in some cases files may not be displayed properly. Example:

Correct | Incorrect
<!--htmlgstart --> <table> ........ </table> <!--htmlgstop --> | <!--htmlgstart --> <table> ........ <!--htmlgstop --> </table>

Back to Top

Can I encrypt ASP files?
Yes. HTML Guardian provides two encryption methods for .ASP files - Standard and Enhanced. A comparison between them you can read in the "Protecting ASP files" section of the Help file. In Standard mode, by default HTML Guardian will only encrypt the server-side parts of the code for .asp files, but you can encrypt parts of the client-side html and script code as well.
Server-side code is not visible to the web site visitors if they view the page source or save the .asp file to disk. But it is what takes most of the time and efforts when you develop asp solutions. So this option can be very useful if you need to give the asp source to some third parties - they can test what you've done on their server, but can't steal your source. In general, it is a good idea to encrypt .asp files even if you don't give them to anyone - this will protect your work if someone for example knows your password and can have ftp access to your server. There are also several bugs in Microsoft's asp server that make possible a knowledgable person to retrieve the real source code of your .asp files if the asp server is not well configured. In most cases the asp server configuration is done by somebody else and you can't know if it's vulnerable to such attempts - so it's always better to protect your asp source code.
In Enhanced mode, HTML Guardian encrypts asp files and the client side code in the server's response entirely. Some other features are also only available in Enhanced mode.
Back to Top

Can I encrypt cascading style sheets(.css) files?
Yes. Encryption of .css files is explained here. If you define the styles within the html file, they will be encrypted as everything else.
Back to Top

Can I protect flash animations?
No. HTML Guardian can't do anything in regard to flash (.swf) files included in your site. It can only make it much harder for your visitors to save the flash files used in your website, but it can not protect them, and will not alter them in any way.
Back to Top

Which protection method I should use? What's the difference?
If you use the default method (for 'All' browsers), the encrypted files will work in all available browsers. If you use the alternative method for IE5+ only, encrypted files will be properly displayed only in Internet Explorer 5.0 or higher.
The default method uses standard javascript for encryption. The alternative method uses some features available in Internet Explorer 5.0 or higher only.
The alternative encryption method for IE5+ is faster and more secure, it is practically impossible to be cracked. Many web designers create a separate version of their sites for each browser. In this case you can encrypt the IE version of your site using the alternative method, and use the default method for others. The alternative method can be also used if you create files for internal use, because IE is the standard browser for almost all organizations. It's also suitable if you create files which will be used offline, like e-books or manuals in html or chm format.
We suggest that you use HTML Guardian's Site Manager. It will encrypt your site(or any set of files that reside in one folder) both for 'All' and 'IE5+' browsers and will generate a file which will redirect the visitors to the appropriate encrypted version of your files depending on the browser used. This way people that use IE 5 or higher(now about 95 % of all web users) will see the files encrypted for IE 5+ browsers, and the rest will see the files encrypted with the default method (for 'All' browsers).
Back to Top

Can I password protect a page? How secure is this?
Yes. There are two types of password protection - Basic and Ultra-Strong.
To use the Basic protection, just check 'Password protect this page' box, and in the password configuration window set the password and the action in case the visitor enters an incorrect password. Of course, this is not a PGP sort of protection :) , so don't use this feature to protect highly sensitive information.
However, it is practically impossible to extract the password from the encrypted file, especially if you use the alternative encryption method(for IE 5+ only).

If you need to protect highly sensitive information in an extremely secure way, you have to use the Ultra-Strong password protection. How to do this is explained here.
Back to Top

What will be encrypted?
For html and frameset files, everything will be encrypted except some parts of the head tag, such as meta tags(unless you check 'Encrypt Meta Tags' box) and title - they will remain unchanged .Of course if you select partial encryption only parts of the code specified by you will be encrypted. Scripts are always entirely encrypted.
Back to Top

Do I need to use all protection options available? What's the recommended set of options?
Of course, you don't have to use all options together. Some of them we added in HTML Guardian because they were requested by our corporate customers, and are not always needed. There is no recommended set of options, use those you find appropriate. However, we suggest that you always disable right click for html files.
Back to Top

Can I encrypt HTML formatted email messages?
Yes, you can. However, there could be problems if the html file you want to send as an email uses external files(like images, external script files or java applets, or external style sheets). For scripts and style sheets, just include their content in the html code rather than using external files. For images it is harder, the only way to send encrypted html file with images inside is to make the images available on the web. So your IMG tags should look like this before encryption:
<IMG src = "http://www.yourdomain.com/images/picture1.jpg">
This is because of the way external files are handled when you send html formatted mail.
Back to Top

I don't want my site to be visited with certain browsers. Is it possible to deny access to my site if it is visited with certain browsers?
Yes, you can. You should create a browser detection script for that. The best way is to put this script in a separate .js file, let's say brwsr_detect.js
Then you should add a reference to this script in each of your html files like this
<script src='brwsr_detect.js'></script>
The above line should be included in the HEAD section of all your files for which you want to detect the browser.
Below is a simple browser detection script( there are much better examples available on the web which can detect the browser build, the OS, the browser support for different plug-ins and many other things):

if(document.all&&!document.getElementById){brwsr='ie4'}; //Internet Explorer 4.x
if(document.all&&document.getElementById){brwsr='ie5'}; //Internet Explorer 5.0 or higher
if(document.layers){brwsr='nn4'}; //Netscape 4.x
if(window.sidebar){brwsr='nn6'}; //Netscape 6.x
if(navigator.userAgent.toLowerCase().indexOf('opera')>=0){brwsr='opera'}; //Opera
//alert(brwsr)

Now let's say you don't want your site to be visited by Opera browsers - you should include a line like this in the script:
if(brwsr=='opera'){document.location='error.htm'};

This will redirect Opera browsers to the error.htm page (you should create it). It may say something like
'This site can't be viewed with your browser. Internet Explorer 5+ or Netscape 6+ is required'
Netscape's 4.x implementation of javascript is awful - the above script may not work in some Netscape 4.x versions. If you don't want your site to be visited by Netscape 4.x browsers, it's better to include this in each page or at least in your main page (not as a .js file but directly in the html source, HEAD section):

<script>if(document.layers){document.location='error.htm'}</script>
Back to Top

Which file types I can protect with HTML Guardian?
HTML Guardian can directly protect the files of the following types:
*.htm / *.html / *.shtm / *.shtml / *.stn / *.asp / *.js / *.vbs / *.css / *.php/ *.inc (.inc files are always treated as asp includes).
If Image Guardian is enabled, you can also protect the images in the following formats:
*.jpg / *.gif (but not animated gif's) / *.bmp
No other file types are currently supported. HTML Guardian can not directly protect files in a format different than the ones listed above(like .cfm , .jsp, .swf, .png, .wav, .class, .jar, .cab or any other file type that may be used in your website). By encrypting the source code HTML Guardian will make unauthorized copying of most files of unsupported types much harder, but it will not modify them in any way.
Changing the extension of any file of an unsupported type to spoof HTML Guardian is not recommended and may have undesired results.
Back to Top

Technical issues:

How to remove the banner from encrypted files?
If you purchase HTML Guardian Professional or HTML Guardian Enterprise Edition, the banner will not be included in the encrypted files.You can do this here.
But we suggest that you first test the free Personal edition which has all the features of the Professional / Enterprise editions.
A complete comparison between HTML Guardian Personal, Professional and Enterprise editions you can see here.
Back to Top

Will encrypted files be displayed correctly in all browsers?
The current version of HTML Guardian has been tested with versions 4.0 and higher of Internet Explorer, Netscape and Opera browsers. However, encrypted files should work fine in any javascript enabled browser on any platform. There is no requirement for a specific version of javascript, the very first one is enough. HTML Guardian automatically adds <noscript> tag to all encrypted html files, which will be displayed if the browser is not javascript enabled(but such browsers are something really exotic and hard to find these days).
Of course, files encrypted with the alternative encryption method(for IE 5+ only) will not work in other browsers.
Also, encrypted files will work in all browsers built on Internet Explorer(no matter what encryption method was used), like NetCaptor, FastBrowser, ClickGarden, etc.
Back to Top

Can I encrypt files created on Macintosh computers?
Yes, you can. Note that Ascii files created on MAC/UNIX(like) systems are different from ones created on Windows, although the differences are not visible - Mac/UNIX use different characters to mark a new line. That's why the files should be converted to Windows format before encryption.
HTML Guardian will detect and convert such files automatically in most cases, but if you have problems with files created on non-Windows machines, you should convert them to Windows format before encryption.
There are several programs that can convert files from any format to Windows format, like for example UltraEdit (click File --> Conversions --> UNIX/MAC to DOS)
Back to Top

Will encryption increase the size of the protected file?
Not really. Typically HTML Guardian will add less than 1K to the encrypted files, if no additional options are used. If you select all additional options, this will additionally increase the size with about 1K. (For personal edition, additional 1K will be added because of the HTML Guardian banner). This is practically nothing, it will increase the download time with less than a second if your visitors use 28.8 modem, which is something really rare these days.
The above applies only to small files, like 10K or smaller. If the file to be encrypted is bigger, the encrypted file could be even smaller than the original. That's because HTML Guardian compresses the code before the encryption, i.e. it entirely removes html formatting.All unnecessary blank lines, new lines, tabs, spaces and so on(which otherwise make your code look steady and easily readable) are removed.
Back to Top

How to encrypt multiple files at once?
There are several ways to do that.
- To encrypt quickly all files in a folder, click 'Select folder', then set the desired protection options and click 'Encrypt'. All appropriate files in that folder will be encrypted. Encrypted files will be saved in a Folder_name_E folder under the same names. This method has some limitations - all files will be encrypted with the same set of protection options.
- For maximum flexibility, use HTML Guardian's File List Manager. This way you can encrypt at once sets of files which reside in different directories, and you can use different protection options for each file.
- HTML Guardian also offers a full command line support. You can use this feature to control HTML Guardian from another applications like your own VisualBasic, C etc. programs.
File List Manager and Command line reference and some examples you can see here.
- To encrypt an entire website (or any set of files that reside in one folder) both for 'All' and 'IE5+' browsers with different protection options for each file, use HTML Guardian's Site Manager. It will make two separate encrypted copies of your site and will generate a file which will redirect the visitors to the appropriate encrypted version of your files depending on the browser used. This way people that use IE 5 or higher(now about 95 % of all web users) will see the files encrypted for IE 5+ browsers, and the rest will see the files encrypted with the default method (for 'All' browsers).
Back to Top

The encrypted file loads slow!
This could happen for big html or script files encrypted for All browsers. If it takes too much time for the browser to process the encrypted file, change the All browsers encryption method to Type II or Type III - they are optimized for bigger files. Or just check 'Automatically select encryption method' box. You can do this from the General Settings configuration window.
Back to Top

The encrypted file doesn't work!
There could be several reasons for that, but you can be sure HTML Guardian is not one of them :)
Of course, first ensure that the original file works as expected. Make sure you have the latest version of HTML Guardian - the latest version available and the current built numbers of the Encryption engine and CodeAnalyzer engine are always listed on our website. There you can also read about syntax requirements your files should comply with, although they are very basic and simple.
Read the "Known Issues" section of the Help.
To avoid errors, save encrypted file in the same folder as the original under a different name - this will ensure that all relative paths are correct.
Additional protection options are not available for .vbs files.
When encrypting multiple files at once, some of the HTML Guardian syntax checkers are disabled. If you have problems with a file encrypted that way, try to encrypt it again separately.
If you have selected the 'Disable offline use' option, encrypted file will not work if you just double click it in windows explorer. To work, such file should be requested through http protocol. You have to upload it to some web server, or you can also test it offline if you have some http server installed, like the http server which is a part of Microsoft IIS(Internet Information Services). To test the file using a local http server, copy it to the server's root folder, then in the url field of your browser type: http://127.0.0.1/filename.htm
Of course, you're are always welcome to contact our support team in case of any problems.
Back to Top

Password protected file is displayed even if I enter a wrong password.
This only looks like a bug. If you choose 'Display blank page' in case of incorrect password, this could never happen. If you choose 'Go back', but then you directly open the file(not by clicking a link to it in another file) it could happen, if you're testing the file offline. It could also happen if you choose to redirect the visitor to another url and you're testing the file offline.
These problems will not appear when your protected page is requested from web server.
Back to Top

Referrer check doesn't work.
This option will not work if you test the protected page offline, you have to put it online. Always check pages protected this way online! Note that some web servers does not support this option. If the online test fails, you host your site on such sever - in this case, don't use it.
Back to Top

You said HTML Guardian will dramatically increase visits to my site, but there is no difference at all.
We said that it could do so, not that it will !
By encrypting your site, HTML Guardian will protect it from being blocked by web content filters. Read more information here.
Many of our customers reported a noticeable increase in visits to their sites immediately after they started to use HTML Guardian. Some of them reported 2,3 or even 5 times more visits per day!
However, this depends on the nature of your site. If it is not likely to be blocked by web content filters, you don't have to expect more visits as a result of encryption. Also, HTML Guardian can't help if the filters block your site by its URL.
There are two ways web content filters block sites - by URL and by scanning the html code for certain keywords. Using the first method only is now considered unreliable because it requires maintaining huge databases with millions of URL's which has to be updated daily. Good content filters use both methods together. You can be sure that eBay.com, Amazon.com, Formula1.com, Travel.com, Download.com or mp3.com are blocked by their URL's. But sites which are not so popular and are not in the URL blacklist, are blocked after scanning their code for 'bad' words. If this is the case for your site, HTML Guardian can surely help.
Back to Top

I lost my original files! Can you help me recover them?
Sorry, we can't do this. Please don't ask us. We regularly receive emails like "I replaced my original files with encrypted ones by mistake, can you help me recover them?". We did our best to help users of HTML Guardian avoid such problems. HTML Guardian will never overwrite the original file with the encrypted one by default. The only exception is if you use a file list or a batch file to encrypt multiple files at once, and you specify the same filename for the input and the output file.
So be careful when creating file lists and batch files, and always backup your work.
Back to Top

Where is CodeAnalyzer? How to access it?
CodeAnalyzer is still here. However, since version 5.0 all Code Analyzer engine settings can no longer be accessed from the user interface. During the beta test period we found that the too many options it has tend to confuse the users. That's way the CodeAnalyzer engine was almost completely rewritten. Now it runs in the background and sends feedback commands to the Encryption engine without the need of user intervention.
However you can still configure the most important Code Analyzer engine settings from the Profiles and Advanced Settings window.
Back to Top

I see an error message "Component 'xxxxx.yyy' or one of its dependencies not correctly registered: a file is missing or invalid " when I start HTML Guardian or when I try to use some feature. What to do?
This means some .ocx or .dll file is either missing, corrupted or improperly registered on your system. HTML Guardian setup package includes all such files which the program needs to run, but you can still see this error message in some cases ( for example if you uninstall some other program, the uninstaller may remove some file which HTML Guardian needs ).
If you see this message,you can mail our support team for the missing file, but you can also find it yourself - just go to Google or some other search engine and enter 'xxxxx.yyy' or 'download xxxxx.yyy' as a search phrase - there are a lot of sites from where you can download .ocx or .dll files.
After you download the missing file, copy it to your \System32 folder. Then click Windows 'Start' button, click 'Run', in the box type
regsvr32 xxxxx.yyy
and click OK. You will see a message that the operation succeeded. That's all, the problem should be fixed.
Back to Top

What HTML Editor I should use to create my pages? What 'HTML Guardian compatible HTML Editor' means?
You can use any text editor(Notepad, UltraEdit, Word etc) or HTML editor(DreamWeaver, FrontPage, HomeSite etc) to create your pages, it doesn't matter at all.
HTML Guardian will encrypt your files no matter what program you used to create them.
Since version 5.0, we no longer issue 'HTML Guardian compatible' certificates to certain HTML Editors. The main reason is HTML Guardian's CodeAnalyzer Engine was greatly improved and now it can handle almost any non-standard piece of code that certain HTML Editors produce.
Back to Top

Virus scanners or internet security programs display alerts about HTML Guardian. What should I do?
Some personal firewalls (like Norton Internet Security etc.) may display an alert that the file htmlg.exe(that's the main HTML Guardian executable) tries to connect to the web. In such case you may configure your personal firewall to deny htmlg.exe any access to the web - this will not affect HTML Guardian's functionality (Professional & Enterprise edition users: the Auto-Update utility executable[hgu.exe] should be able to connect to the web, otherwise you will not be able to use the Auto-Update feature).
Some antivirus programs may also display alerts about htmlg.exe - all such alerts are false and you may ignore them.
For example some versions of Symantec's Norton AntiVirus(NAV) may display an alert like "Malicious script detected" - in this case configure NAV to "Authorize this script", or choose the option with the closest meaning from the list of available options.
Most antivirus programs allow certain files to be excluded from virus activity detection. It is strongly recommended that you exclude the main HTML Guardian executable htmlg.exe from virus activity detection, otherwise the program may not work correctly in some cases (you may scan the program's installation folder before doing this to be sure the files are not infected). For some antivirus program you may need to exclude htmlg.exe again after each auto-update.
Each new version of HTML Guardian is scanned with 4 different virus scanners before uploading - you can be sure that the program is not infected.
Back to Top

Encrypted file doesn't work after I upload it to PayPal
Click "Settings" --> "General Settings". Check "Paypal-friendly encryption" box and re-encrypt the file.
Back to Top

HTML Guardian crashes when started on WindowsXP
In some very rare cases, when you start HTML Guardian on a WindowsXP system, you may see an error message like:
"HTML Guardian has encountered an error and needs to close" or similar (or the program may just quit without an error message).
This can be caused by some "tweaking" programs, for example WindowsBlinds or others that carelessly modify the registry.
If you experience such problem, go to HTML Guardian's installation folder (most likely C:\Program Files\HTML Guardian ). Right click on the htmlg.exe file and select 'Properties' from the context menu. Click the 'Compatibility' tab. Check the 'Disable visual themes' box. If available, check also the 'Turn off advanced text services' box.
This settings changes will be applied only to HTML Guardian and will not affect other programs.
Back to Top

HTML Guardian works slow
Could be, on relatively slow machines. HTML Guardian is very different from all other HTML Guardian - like programs. It performs a deep analysis of your source code in order to predict and avoid possible problems and to select the best possible protection for each file. It also tests and debugs the encrypted output and in case of failure, or in case the encrypted file security is unsatisfactory, it may restart the encryption process. All this takes time, but ensures maximum security and performance for the encrypted files.
There are however ways to improve the encryption speed:
- if you do not intend to use Image Guardian, disable it. If it is enabled, the CodeAnalyzer™ engine and the debugging engines perform a lot of additional tasks.
- disable Multi-language support if it is not actually needed. Multi-language support is not needed for pages that are in English and in most of the West European languages like Spanish, Portugese, French, German, Italian, Dutch etc.
Back to Top

Other issues:

What's the difference between HTML Guardian Personal, Professional, Enterprise and Server edition?
The only difference between Personal and Professional edition is that the Personal edition puts a watermark in each encrypted file(for .asp files, it will only encrypt relatively small files, and will not encrypt bigger files in Standard ASP encryption mode - this limitation does not apply to the Enhanced ASP encryption mode). Everything else is absolutely the same, there is no any limited or missing functionality in Personal edition compared to Professional edition.
HTML Guardian Enterprise edition has all the features of HTML Guardian Professional, but it also includes Image Guardian for Enhanced protection of your web site images (Image Guardian is available in HTML Guardian Personal and Professional editions, but its functionality is limited. Image Guardian is fully functional only in HTML Guardian Enterprise Edition). Ultra-Strong password protection utility and the Enhanced ASP encryption are also fully functional only in the Enterprise edition.
Also the HTML Guardian Auto - Update Utility is only available in the Professional and Enterprise editions.

The table below shows all the differences between the Personal, Professional and Enterprise editions.

HTML Guardian Edition: | Personal | Professional | Enterprise
Features available: |  |  |
Banner (watermark) in each encrypted file | Yes | No | No
Enhanced Image Protection ( Image Guardian ) | Yes, limited | Yes, limited | Yes, Unlimited
Encrypt ASP files [Standard ASP encryption] What's the difference between the Standard and Enhanced ASP encryption? | Yes, file size limit | Yes, Unlimited | Yes, Unlimited
Encrypt ASP files [Enhanced ASP encryption] What's the difference between the Standard and Enhanced ASP encryption? | Yes, with a banner | Yes, with a banner | Yes, Unlimited (without a banner)
Encrypt html / shtml files | Yes | Yes | Yes
Encrypt JavaScript (.js) files | Yes | Yes | Yes
Encrypt VBScript (.vbs) files | Yes | Yes | Yes
Encrypt style sheets (.css) files | Yes | Yes | Yes
Ultra - Strong password protection | Yes, limited | Yes, limited | Yes, Unlimited
Auto-update via the web | No | Yes | Yes
Partial encryption capabilities | Yes | Yes | Yes
Encrypt php files | Yes | Yes | Yes
High code compression (without encryption) | Yes, file size limit | Yes, Unlimited | Yes, Unlimited
All other features not listed here | Yes | Yes | Yes

HTML Guardian Server edition is currently beta tested and is not yet available for download. It has a different purpose, the Server edition is designed for protection of server-side generated dynamic content. If you want to try it, please visit our website and join our beta testing program.
Back to Top

Do you offer a money back guarantee?
No. As we stated above, there is absolutely no difference in the core functionality of HTML Guardian Personal and Professional / Enterprise editions.
You can test all HTML Guardian Professional / Enterprise edition features with HTML Guardian Personal edition. Some features are limited, but not missing and can be tested. You can download HTML Guardian Personal edition for free and test it as long as you wish(it will not expire), until you are absolutely confident it fits your needs. Once you are sure it's the right choice, you can purchase the Professional or Enterprise edition.
Back to Top

What is your upgrade policy? If I purchase HTML Guardian Professional or Enterprise, do I have to pay for the new versions you release ?
No. All registered users of HTML Guardian Professional and HTML Guardian Enterprise will receive all future new versions free of charge.
Back to Top

Do you plan to release HTML Guardian for Linux and Mac?
HTML Guardian for Linux is in early stages of development. We hope to release the first public beta version for Linux soon, so please check our beta testing page in case you are interested.
We currently don't plan to release HTML Guardian for Macintosh platform.
Back to Top

Privacy policy:

ProtWare Inc. privacy policy
We will never disclose to any third parties, or make publicly available, any information about our customers, people involved in our beta testing programs, users of our free products, or any individual or entity we have been in contact with regarding our products.
Back to Top


HTML Guardian features

Main HTML Guardian features:

  • A world standard for web intellectual property protection
    • - all the experts in web design, web security and intellectual property protection recommend HTML Guardian.

  • Rock solid
    • - it will properly encrypt all html, shtml, script and asp files, not only some of them. HTML Guardian's revolutionary CodeAnalyzer™ engine debugs the encrypted code in realtime and sends the appropriate feedback commands to the encryption engine. This ensures 100% working and error-free encrypted files.

  • Flexible encryption options:
    • Encrypt html files, asp files, external script files(.js or .vbs), shtml files, framesets and style sheets (.css) files. You can also encrypt HTML formatted email.
    • Protect your images with Image Guardian.
    • Encrypt only desired parts of html files.
    • Two different methods of encryption
      • - files encrypted with default method will work in all javascript enabled browsers. You can also use the alternative, more fast and secure method for Internet Explorer 5.0 or higher only.
      Actually HTML Guardian uses more than 30 different encryption algorithms, but you do not have to wonder which one to choose - the CodeAnalyzer™ engine automatically selects the most suitable one.
    • Disable right mouse button.
    • Disable showing link targets in status bar.
    • Disable text selection.
    • Prohibit offline use
      • - your files will work fine when someone is browsing your site, but will not work if they are saved and run from a local hard drive.
    • Password protect your pages.
    • Prohibit linking your pages from another sites.
    • Prohibit printing of protected files.
    • Disable Clipboard & Print Screen ( for IE 5+ only ).
    • Option only to compress HTML code(without encryption).

  • Encrypt either a single file, entire website or a file list at once.

  • Full command line support.

  • Language independent
    • - HTML Guardian will properly encrypt your files no matter what character set you use. You may have texts in English, Chinese, Russian, Japanese or any other other language.

  • Powerful partial encryption capabilities
    • - encrypt only those parts of the code you want.

  • Profiles
    • - quickly apply predefined sets of protection options.

  • Smart and easy to use interface.

Benefits:

  • Total protection for your website
    • - No portion of your code can be reused by someone else. Changing even a single character in an encrypted file will make it non-working, they can't be edited with HTML editors.
    With ordinary files it's pretty simple to copy any part of the code and use it in another file. You may spend a lot of time to develop state-of-the-art page layouts, complicated scripts or dhtml effects (or you may pay someone else a lot of money to develop them for you) - but once you upload your site, anyone can take and edit your files a bit, then use them as her/his own. No special knowledge or experience is needed, even a beginner can get a complicated page and modify it to fit his needs quickly and easily.
    In today's highly competitive environment, this may have a negative effect on your business. But if you protect your website, you can simply forget these worries. What's yours is yours. Period.

  • Protect your images !

    • Image theft is one of the most common things, and a major concern for many webmasters.
    Image Guardian add-on for HTML Guardian provides enhanced protection for the images on your website. It is an invaluable tool if you have a picture gallery type of a website, or you just don't want your images to be copied by anyone and posted on other websites.
    Image Guardian will also make impossible direct linking to your images from another websites.

  • Dramatically increase visits to your site
    • - keep away all web content filters.
    Current statistics show that nearly 80% of web browsing is done from office, university, school, etc. computers, and only about 20% is done from home computers. But nowadays more and more corporations, government organizations and universities start to use the so called content filters to limit the access to certain web sites. Simply said, content filter is a software which stays between corporate's LAN and the internet and scans all web pages requested by users. Since web pages are actually plain text files, they can be easily scanned for certain 'bad' words. If such words are detected, the page is blocked by the filter and not sent to the user who requested it.
    These restrictions are not only for adult, gambling and similar sites, as you may think. Actually many organizations block access to sites which offer online shopping, sites related to music, fashion, movies, sports, online forums, shareware sites, sites that offer recipes, horoscopes, and many many other things you may never think of.
    It's easy to understand such policy - the management prefers employees not to waste their time for surfing the web. But the result of all this is: web content filters can effectively hide your site from more than 50% of your potential visitors!
    If you encrypt your pages, content filters will still scan them, but will not find anything suspicious. HTML Guardian is permanently being tested against all software of this kind we're aware of - where ordinary files are blocked, encrypted files have no problem at all :)
    Some of our customers reported 2,3 or even 5 times more visits to their sites after they started to use HTML Guardian!

    Encrypting your files is also useful if you want to put a banner or any other kind of advertisement on your site. There is a great variety of personal web content filters available(like AdFilter, AdMuncher, AdSubtract, Norton Internet Security, Proxomitron and many others) which filter out advertisements based on different criteria. Visitors which use such software will not see your banners, but if you encrypt your pages, everyone will see them.

  • Protect your links and all external files
    • - there are many programs which can leech all links from a html document - links to downloadable files, other html files, images, applets, etc. Then someone can simply put these links in another website and make a site similar to yours with no efforts at all, using your work for his benefit. This will not only make your site less competitive, but will also generate additional traffic for which you may have to pay.
    HTML Guardian will not only protect your files and links, but can also save you money in case you pay for the traffic.

  • Stop site rippers
    • - site rippers are programs specifically designed to download entire websites. Such programs are for example Teleport Pro and WebSnake. They can download an exact duplicate of a website, complete with subdirectory structure and all external files referenced in any of the pages. Site rippers are commonly used for creating offline browsable copies of different sites like web based knowledge bases and tutorials, picture galleries and so on. They are multithreaded and can download many files simultaneously, which may overload the server and make your site unavailable for other visitors. Also site rippers generate an enormous traffic - they don't download only what the user may need, but just everything.
    HTML Guardian stops site rippers. They are unable to analyze encrypted files and will download nothing but the page they have been configured to start with.

  • Avoid spam
    • - protect all email addresses on your site.
    So called email spiders can scan thousands of websites per day and extract all email addresses from them. Once some email address is posted online, it will sooner or later appear in some spamming database.
    It is impossible to extract emails from protected sites.


HTML Guardian advanced settings

HTML Guardian general settings

Click "Configuration" --> "General Settings" or press F3 to open the General Settings configuration window. The following settings are available:

[click somewhere on the screenshot to see the associated help topic]

- Insert blank lines in encrypted code - will insert about 40-50 blank lines before and after the encrypted code, so that when somebody clicks View --> Source, he/she will see an empty document.
<<< Go Back <<<

- PayPal friendly encryption - will encrypt the file so that it will be correctly displayed if uploaded to PayPal. Recently PayPal introduced a set of new code guidelines which are to be observed. A file encrypted without this setting may not be properly displayed on PayPal although it will be properly displayed on any other website.

Other websites (very few) might use rules similar to PayPal ones. You may try to set this feature ON and test the page online in case there are problems (but first ensure everything else is OK).
It is not recommended to use this feature if there is no need, although in 98% of the cases files will work OK. Use it only for files you intend to upload to PayPal or sites with similar requirements.

Paypal friendly encryption setting will only have effect for files encrypted for "All" browsers - Type I encryption method, and files encrypted for IE5+ browsers using the "Classic" encryption method. For Files encrypted with IE5+ Enhanced encryption method, this setting will not be applied and such files may not work on PayPal.
This setting will only be applied to htm / html files. You do not have to turn it OFF when you encrypt other file types like shtml / asp / js etc.
<<< Go Back <<<

- Display loading information at startup - if checked, information about loading the most important HTML Guardian modules will be displayed when the program starts. You may turn this feature OFF, but if you experince problems with the program turn it ON.
This feature is only available on Windows NT/2000/XP systems. On 9x systems it doesn't matter whether this setting is checked or not.
<<< Go Back <<<

- Disable multi - language support - you may check this box if you are protecting files that are entirely in English. It can be disabled also for sites that use most of the West European languages, like Spanish, Portugese, French, German, Italian, Dutch etc. If you experience problems with pages that use West European languages, uncheck this box.
Many checks related to multi-language support will not be performed and the program will work faster (it's OK to leave multi-language support enabled even if it's not needed). Files which source code contains any non-ASCII characters may not be displayed correctly if multi-language support is disabled.
<<< Go Back <<<

- Ask for a password only once- you may want to password protect many files, but it will be annoying for the visitors of your site to enter the password for each of them. If this option is selected, the users will have to enter the password only once (the first time they try to open any password protected file). All protected files they want to see afterwards will not ask for a password but will be decrypted using the password entered for the first file.
You can use different passwords - if the user opens a file protected with a password different than the one already entered, he/she will be prompted for a password again.
This option will not work for files opened in a new window (e.g. links with target="_blank" or files opened in a javascript generated window) - for such files users will be prompted for a password again.
Note: If you use this option, the password will not be stored on the user's harddisk or on any other place. The user has to re-enter the password each time he/she re-visits your site.
This setting will have no effect for files which are not protected with a password. You can freely mix password protected and non-password protected files in your site.

This setting only applies to the basic password protection and is not valid for the Ultra-Strong Password Protection Utility. It has a similar option, to use it you will have to check the corresponding box in the Ultra-Strong Password Protection window.
<<< Go Back <<<

- Use Domain Lock instead of 'Don't allow offline use' - If you check this box, when you encrypt a file with the 'Don't allow offline use / Domain Lock' security option selected, HTML Guardian will lock encrypted files to the specified domain instead of just disableing the offline usage of the file.
When you check the box, you'll be prompted for the domain to lock the files to. Enter the domain name only, e.g. your_domain.com, not www.your_domain.com or http://www.your_domain.com.
You may enter a subdomain, like subdomain.your_domain.com.
What's the difference?

- if the box is not checked ['Don't allow offline use' option will be applied] - it will be simply not possible to use the encrypted file offline, like if you save it from the web location to your hard disk and then double click the locally saved copy to view it offline. But it will be possible to view the file if you upload it to another web server, or if you view it through a locally installed http server.

- if the box is checked ['Domain Lock' option will be applied] - in this case it will still not be possible to use the encrypted file offline, but it will be also impossible to view the file if you upload it to another web server, or if you view it through a locally installed http server. The file will work only if it is requested from your domain and on no other place.

Note that if 'Domain Lock' is used, it will not be possible to test the encrypted files on your PC - you will have to upload them to your server in order to view them.

An important note about ASP files encryption:
If you select any additional protection option when you encrypt an .asp file, HTML Guardian automatically adds 'Don't allow offline use / Domain Lock' protection, even if this option is not selected. This means that if you use Domain Lock, you will not be able to test encrypted .asp files through a local server, because they will be locked to your domain.
If you encrypt an .asp file without any of the additional protection options selected, 'Don't allow
offline use / Domain Lock' protection will not be applied automatically.
<<< Go Back <<<

- Default encryption method for 'All' browsers- HTML Guardian offers 3 different encryption methods for 'All' browsers. In general it is recommended to use Type I encryption for files up to 30-50 K in size. For files between 30-50 to 130-150 K use Type II encryption, and for larger files use Type III.
If you check the "Automatically select encryption type" box, HTML Guardian will automatically choose the most suitable encryption method for each file.
Of course you may use any encryption type for any file, but Type I is optimized for small, Type II for medium and Type III for big files. In many cases there will be no visible difference in encrypted files performance if you change the encryption type, but in some cases there could be a significant difference.

Switch to another encryption type if the encrypted file is not displayed correctly or shows error messages.

You can quickly change the encryption type by pressing ALT + 1, ALT + 2 or ALT + 3 keys to apply Type I, II or III respectively. To see the currently used encryption type, press F4.
<<< Go Back <<<

- Default ASP encryption settings - here you can choose between Standard and Enhanced ASP encryption. A comparison between both you can read here.
If you check the 'Encrypt server response' box, the client side code in the asp file will be encrypted in the server's response. This means it will appear encrypted when a visitor of your site clicks View --> Source. If this box is not checked, the entire code will appear unencrypted in the visitor's browser.
Note that this option works different in Standard and in Enhanced encryption modes.
You can test encrypted ASP files using a local HTTP server. Click the 'Testing...' button to configure this option. In the first box enter the full path to the folder where your asp files reside. This should be either the server's root folder or some of its subfolders. It is also possible to use a virtual folder. In the second box enter the URL of that folder for your PC, it should normally look like http://127.0.0.1/folder_name/
Windows 2000 and XP come with a built-in http server. You can use it if Internet Information Services (IIS) are installed. If IIS are not installed, you can do this from the Control Panel --> Add/Remove Programs --> Add/Remove Windows components. For Windows 9x/Me you may use a third party Http server.
Note that the Enhanced ASP encryption is fully functional only in HTML Guardian Enterprise edition. A complete comparison between the Personal, Professional and Enterprise editions you can see here.

Auto-import ASP includes - if this box is checked, the includes the currently encrypted asp file uses will be automatically merged(imported) into it before the encryption starts.
This means that if the currently encrypted .asp file contains for example the following tag:
<!--#include file = "my_include.asp" -->
this tag will be replaced with the actual source code of the my_include.asp file.

Using this option will result in:
- a standalone encrypted .asp file that does not need any includes to work - the includes will be merged into it, so the encrypted asp file will not depend on any external .asp / .inc files.

- a bigger file - the size of the encrypted file will be bigger, because it will contain the encrypted asp code of the main file + the encrypted code of the includes it uses. However, for the visitors of your site there will be no difference at all - the size of the code sent to the visitor's browser will be the same, no matter whether you use this option or not. Actually, the files with merged includes will be processed faster (see below).

- faster files processing - if an asp file uses includes, when this file is requested the server parses it first, then it looks for and opens all the includes it uses, then it parses the found includes for any includes they use and so on. If all the includes are merged into the main file, the server does not have to perform any additional operations - this may increase the performance a lot.
Auto-import ASP includes feature has the following limitations:

- only 2 levels of includes will be imported.
Let's illustrate this with the following example:
We want to encrypt the file main.asp.
It uses the level1.asp file as an include.
level1.asp file uses the level2.asp file as an include.
level2.asp file uses the level3.asp file as an include.
When the encryption starts, first the level2.asp file will be merged into the level1.asp file. Then, the level1.asp file (with the level2.asp already merged into it) will be merged into the main.asp file. Then, the main.asp file will be encrypted.
But, the level3.asp file will not be merged into the level2.asp file. The encrypted main.asp file will still need the level3.asp file to work. However, using more than two levels of nested includes is a very rare situation, so this limitation is mostly theoretical.

- only files included with the <!--include file = '...' --> statement can be auto - imported.
Files included with the <!--include virtual = '...' --> statement can not be auto-imported.

- No other files, except the ones included with the <!--include file = '...' --> statement can be auto - imported. Client - side script files (.js / .vbs) referenced this way
<script src = 'my_script.js'></script>
, .dll's or whatever other files will not be auto-imported - the encrypted asp file will still need them to work properly.

- only files included with a path relative to the file being encrypted can be auto-imported.
If the includes are included with an absolute path, or with a path relative to the site root folder, they will not be auto-imported.
Let's see an example:
If we encrypt a file that uses an include like this:
<!--#include file = "my_include.asp" --> this is OK. The include path is relative to the file that uses the include.
If the file uses an include like this:
<!--#include file = "/my_include.asp" --> - this is not OK - the include path is relative to the site root folder, not to the file that uses the include.
<!--#include file = "http://www.mydomain.com/my_include.asp" --> this is not OK - file is included with an absolute URL.

If you experience problems with the encrypted asp file, change the 'Auto-import ASP inludes' setting.

<<< Go Back <<<

- Code compression level- HTML Guardian always compresses the code before encryption (for html, shtml, js and css files only - vbs and asp files are not compressed). Here you can set what compression level to use.
High compression will remove any single useless bit from the files - all comments, empty lines, unneccessary new lines, tabs, code formatting etc. - in most cases the result will the entire file placed in one line.
Low compression is a bit more conservative and will remove only some of the useless characters.
It is recommended to use the High compression, switch to Low only in case of problems.

Change the code compression level if the encrypted file is not displayed correctly or shows error messages.

You can quickly change the compression level with CTRL+ALT+H and CTRL+ALT+L keys to apply High or Low compression respectively. To see the currently used compression level, press F4.

Note: High compression is significantly slower than Low compression because a lot of additional operations has to be performed. However the High compression may decrease the file size (and improve encrypted file performance) a lot, so it is recommended to use it. Switch to Low compression in case of problems with the encrypted file.

Note: High compression will not tolerate 'free-style' javascript coding.
The following two scripts will have the same result:

<script>
var a = 5;
if(a==5){alert('a is Five')}
else{alert('a is NOT Five')}
</script>

<script>
var a = 5
if(a==5) alert('a is Five')
else alert('a is NOT Five')
</script>

What's the difference ?
The first script is OK. The second one uses a 'free-style' coding.
Each If or If...else in your javascripts should look like

If (condition){stuff to do if condition evaluates to True};
or
If (condition){stuff to do if condition evaluates to True}
else{stuff to do if condition evaluates to False};

Do not omit { } brackets. Although javascript is quite tolerant and will not display an error message if you omit the {} brackets, this is still a bad coding practice. High compression is not so tolerant, and may fail if you use free-style javascript coding.

If you want to use 'free-style' coding scripts, switch the Code Compression Level to 'Low compression' .
<<< Go Back <<<

Go back Next

© 1997-2003, ProtWare Inc. All rights reserved.

Multi language support Loading information Protect PayPal files Insert blank lines in encrypted code Default encryption settings for All browsers Use Domain Lock ASP encryption settings html code compression Ask for a password once


HTML Guardian history

HTML Guardian version history

July 2003 - HTML Guardian v6.6.0 was released.
Version 6.6.0 contains a new, much more enhanced algorithm for encryption of .ASP files.
It has a lot of new features and provides a much better asp encryption. Most of the limitations in regard to asp files protection are removed.
Version 6.6.0 also has some bug fixes, new CodeAnalyzer knowledge base entries and user interface improvements.

May 2003 - HTML Guardian v6.5.4 was released.
Version 6.5.4 has a completely new code compression algorithm. It will remove any single useless bit from your files before the encryption.
- HTML Guardian can automatically select the most suitable encryption method for each file.
- improved encrypted files security.
- new CodeAnalyzer™ knowledge base entries.

October 2002 - HTML Guardian v6.4 was released.
Version 6.4.0 has many improvements in regard to ASP files protection:
- Encrypt ASP files that use encrypted includes.
- Encrypt client-side html / script code in ASP files.
Minor user interface improvements.

September 2002 - HTML Guardian v6.3 was released.
Increased encrypted files security.
Additional protection options can be used for .asp files.
CodeAnalyzer™ engine and Encryption engine speed was increased.
A new feature, Customized browser layout, was added to Site Manager. You can define which parts of the browser's interface to be enabled for your protected site - you can optionally remove the URL(address) bar, Status bar, Tool bar, Menu bar from the browser's interface, open your site in FullScreen mode etc.
Enhanced support for double byte languages.

July 2002 - HTML Guardian v6.2 was released.
Version 6.2 introduces the Image Guardian add-on for HTML Guardian - a tool for enhanced protection of your website images.
No doubt this was the most requested HTML Guardian feature ever - we have received thousands of emails asking us for yet better image protection functionality.
Another new feature in v 6.2 is the Site Manager, a tool to encrypt your entire web site with a few clicks.

April 2002 - HTML Guardian v6.0 was released.
Many new features and improvements were introduced in HTML Guardian 6.0.
The new Profile Manager let's you create profiles which contain predefined settings for the encryption options, Code Analyzer, Encryption and Debugging engines.
It's possible to fine tune some of the HTML Guardian's advanced settings, such as Code Analyzer engine Heuristics Sensitivity Level, debugging options and much more.
Many improvements in Code Analyzer, Encryption and Debugging engines.
User interface improvements.
And much more ...

January 2002 - HTML Guardian v5.6.0 was released.
Two of the most requested features were implemented in this version:
File List Manager - you can create file lists and set different protection options for each file in the list.
Much more powerful partial encryption - now you can specify not only parts of the code to be encrypted, but also parts of the of the code to be skipped.

December 2001 - HTML Guardian v5.5.5 was released.
Fixed bug that caused program crashes in some rare cases of .shtml files encryption.
Added Auto Update Utility which downloads and installs new versions of the program automatically (only available in Professional Edition).

November 2001 - HTML Guardian v5.5.0 was released.
Increased security for encrypted files.
Optimized add-ons, Internet Explorer 6 Image Toolbar is automatically disabled in encrypted files if 'Disable right click' option is selected.
Improved browser compatibility.
Several bug fixes.

September 2001 - HTML Guardian v5.4 was released.
Added support for encryption of .shtml files.
Several bug fixes.
Increased security for encrypted files.

August 2001 - HTML Guardian v5.3 was released.
Added option to encrypt Meta tags.
Added option only to compress HTML code(without encryption).
CodeAnalyzer™ engine improvements, better support for some new features in Internet Explorer 6.

July 2001 - HTML Guardian v5.2 was released.
Added support for partial .ASP files encryption (only the server-side code is encrypted).
Added option to disable printing of protected files ( only for Internet Explorer 5 or higher ).

May 2001 - HTML Guardian v5.0 was released.
CodeAnalyzer™ engine was made self-adapting, the user no longer needs to configure it.
The way CodeAnalyzer™ engine and Encryption engine interact was completely changed.
CodeAnalyzer™ engine speed was greatly improved - debugging in Internet Explorer, Netscape and Opera is now simultaneous.
Added option to prohibit offline use of encrypted files.

January 2001- HTML Guardian v4.7 was released.
Added CodeAnalyzer™ support for Opera.
CodeAnalyzer™ engine speed was improved.
Encryption engine speed was improved.
Added option to disable text selection.

September 2000 - HTML Guardian v4.3 was released.
Added full command line support for easy automation of common encryption tasks.
Added referrer check option.

April 2000- HTML Guardian v4.0 was released.
Added CodeAnalyzer™ support for Netscape.
The option for separate encryption for Internet Explorer and Netscape was removed.
New debugging options added to CodeAnalyzer™.
Added option for password protection of encrypted pages.

December 1999- HTML Guardian v3.6 was released.
Added support for partial encryption of html files.

November 1999 - HTML Guardian v3.5 was released.
It introduced the revolutionary CodeAnalyzer™ engine used to debug the encrypted code and allow the user to change several options in case of problems. In this release, only Internet Explorer was supported by CodeAnalyzer™.
Added option for separate encryption for Internet Explorer and Netscape browsers.
Several bug fixes.

April 1999 - v3.0 was released.
W-Cypher! was renamed to HTML Guardian.
Several new protection options added.
Added support for encryption of frameset files.
Added option to encrypt all files in a folder at once.

April 1998 - W-Cypher! v2.0 was released.
Added support for encryption of javascript(.js) files.
Encryption speed was improved.
Several bug fixes.

June 1997 - W-Cypher! v1.0 was released. It was only able to to encrypt html files.

April 1997 - first public beta of W-Cypher! was released.


HTML Guardian Help

Welcome to HTML Guardian Help.

Please note that there could be a newer version of this file. To get the most recent version, please visit ProtWare's website.

To start using HTML Guardian immediately, please read 'How to use HTML Guardian' section of the help for a detailed explanation of all the settings and options.

Most questions you might have are hopefully answered in our FAQ and in the other sections of this document. If you need some additional information, you are welcome to contact our support team.

Click [image] button at the top left corner to open the search pane.

Click [image] button to return to this window.

Thank you for using HTML Guardian!


Image Guardian

Image Guardian - the tool to protect your images

  • What is Image Guardian and why is it needed? What are the benefits?
  • Image Guardian configuration
  • Image Guardian specifications and limitations - what it can and what it can't do
  • Image Guardian and HTML Guardian Profiles & File lists
  • Image Guardian FAQ & Troubleshooting
  • How to protect a single image that is not included in a html file? How to protect my image gallery?

What is Image Guardian and why is it needed? What are the benefits?

Image Guardian is an add-on to HTML Guardian for enhanced protection of the images in your web site.

HTML Guardian can protect your entire website, with one exception - it can't fully protect your images. HTML Guardian can do a lot to make image theft much harder. If you choose to disable the right click in the encrypted file, visitors will not be able to right click and select 'Save image..' from the context menu (this will also disable the IE6 Image Toolbar). If you choose 'Save As' from the 'File' menu in Internet explorer, it will save the html file and all images and other files referenced in it. But if the file is encrypted, images and other files will not be saved.

However, when someone browses your site all images included in html files are first downloaded and then displayed. So all your images are somewhere on visitor's hard drive and someone can find them, although that's not so easy and most internet users don't know how to do it.
But a knowledgeable person can steal all your images.

Here comes the Image Guardian - it will split your images into pieces and will generate the appropriate code (which will be then encrypted by HTML Guardian) to display those pieces in your pages as if this is an integral, non-splitted image.
This will make image theft nearly impossible - if someone wants to get some of your images, he/she will not be able to get the entire image, only a pieces of it saved under random, meaningless names. It will be very hard to determine that a certain piece is a part of a certain image. Let's say your website has 10 images, and you configured Image Guardian to split them into 3x3=9 pieces each - this will result in 90 image pieces with random names, mixed with a lot of images from other websites visited. A determined person may still be able to find all the pieces of a certain image, but finding them and joining them together to recreate the original image will require a lot of time, knowledge and expensive image editing programs(like Photoshop or similar). In most cases this will also lead to a decreased image quality. We can say Image Guardian will decrease the risk of image theft with 95-98% (but not 100%).

Let's summarize the main benefits of Image Guardian:

  • - image theft will be nearly impossible

  • - direct linking to your images from another websites (something very common) will be absolutely impossible

  • - big images will load faster if splitted

  • - the code that loads the image will be encrypted using the award winning HTML Guardian code protection technology
Image Guardian is fully functional only in HTML Guardian Enterprise edition.
In HTML Guardian Personal and Professional editions, Image Guardian will only protect images which height is significantly bigger than their width, like for example 100 x 350 pixels, 50 x 160 pixels etc (width x height). Images like 100 x 100, 300 x 100 pixels etc will be skipped.
A complete comparison between HTML Guardian Personal, Professional and Enterprise editions you can see here.
In the \Samples subfolder of the HTML Guardian installation folder you can find some images and html files you can use for testing Image Guardian with HTML Guardian Personal and HTML Guardian Professional Edition.

Go back

Image Guardian configuration

To open Image Guardian configuration window, press Ctrl + I or click 'Image Guardian' under the 'Tools' menu.
Any image sizes mentioned here should be read as image width x image height in pixels.

The following settings are available:
[click somewhere on the screenshot to see the associated help topic]

Enable Image Guardian - if checked, Image Guardian will start when HTML Guardian starts and will protect the images in the files you encrypt. If not checked, Image Guardian will not start when HTML Guardian starts and the images inside the files HTML Guardian encrypts will not be protected.
HTML Guardian Personal and Professional edition users: In case you are not testing Image Guardian, it is recommended to disable it. If it is enabled, the CodeAnalyzer engine performs a lot of additional operations which may slow down the encryption process.
<<< Go Back <<<

When HTML Guardian is running, you can press Ctrl + Alt + I keys to toggle Image Guardian OFF/ON. Press F4 at any time to see the current settings.
<<< Go Back <<<

Use random names - if checked, the pieces of the protected image will be saved under random, meaningless names. If not checked, the pieces of the protected image will be saved under names generated based on the original image file name. Let's say there is an image named cat.jpg, and you selected to divide the images into 2x2 pieces - if 'Use random names' is not checked, the image will be splitted into 4 files named cat1.jpg ... cat4.jpg. If 'Use random names' is checked, cat.jpg will be divided into pieces named like dffghre.jpg, eerwrw.jpg, fbnza.jpg, kllwj.jpg
<<< Go Back <<<

Enable smart detection - in some cases the page layout changes (some elements are transposed) after you encrypt a page with Image Guardian enabled - this problem is explained here. If this box is checked, Image Guardian will use a different algorithm and the problem will most likely not appear.
<<< Go Back <<<

Put protected images in xxx subfolder - if you enter some folder name here, like e_imgs, each protected image pieces will be stored in the specified subfolder of the folder where the original image is.
Let's say we have a page with 3 images inside, pic1.jpg, pic2.jpg and pic3.jpg
pic1.jpg and pic2.jpg are in the same folder where the html file that uses them resides, and pic3.jpg is in the /myPics subfolder of the folder where the html file that uses the images resides.
After encryption, pic1.jpg and and pic2.jpg pieces will be saved in /e_imgs/ subfolder of the folder where the html file is.
img3.jpg pieces will be saved in /myPics/e_imgs/ subfolder of the folder where the html file that uses the images resides.
You have to recreate the exact folder structure when you upload your site to your server. This means you have to upload the /e_imgs/ subfolder to your server for the protected pic1.jpg an pic2.jpg to be visible, and to upload also the /myPics/e_imgs/ folder for the pic3.jpg to be visible.

If you leave this field blank, the pieces of all protected images will be saved in the same folder where the original image is.
We suggest always to put protected images in a separate folder. If you protect your website and after some time you make some changes and protect it again, if 'Use random names' option is used, all images will be splitted into pieces with new names. Then it will be impossible to determine which piece is needed and which one is already useless. If you keep protected images in a separate folder, you can simply delete all files in it before protecting your site again.
<<< Go Back <<<

Only protect images bigger than X x X pixels
In many websites there are a lot of small images for which there is no need of whatever protection. Here you can specify the minimum image size that does not need a protection.
If you specify here let's 50 x 50 pixels as a minimum image size, any image with a width < 50 pixels and a height < 50 pixels will not be protected. All images outside this range will be protected, like 100 x 30 pixels images.

There are two ways to define how to split the protected images - you can choose to split them always into fixed number of pieces regardless of their size (check Always divide images into X x X pieces) or you can choose to fix the size of the pieces, in which case bigger images will be splitted into more pieces (check Divide images into pieces with a side of X pixels). Note that if you use the second option, the value specified for the side of the pieces will not be strictly observed, it will only be used by Image Guardian as a basis to calculate the actual number of pieces to split the image into. If for example you enter 100 pixels there, 250 x 200 pixels image will be divided into 4 pieces 125 x 100 pixels.
Any image bigger than the specified minimum size will be divided into at least 2 pieces. If you specify 50 x 50 as a minimum size and 100 pixels image pieces size, 80 x 40 image will be divided into 2 pieces 40 x 40 pixels each.
The smallest acceptable minimum image size is 40 x 40 pixels.
<<< Go Back <<<

Quality - the quality of the protected image pieces. We suggest to leave the default value of 85 - this will preserve the original image quality without increasing the image size. Setting this value to 85 does not mean that the original image quality will be decreased by 15%.
Any value outside the acceptable range of 60 - 100 will be ignored and the default value of 85 will be used instead.
<<< Go Back <<<

Run Image Guardian in Safe Mode - check this box if you experience problems with protected files (images are not protected, protected images are not displayed in the encrypted files etc.). HTML Guardian will encrypt the files slower if Image Guardian runs in Safe Mode.
When HTML Guardian is running, you can press Ctrl + Alt + S keys to toggle Image Guardian Safe Mode OFF/ON. Press F4 at any time to see the current settings.

Safe Mode level ( 1 - 10 ) - in case Run Image Guardian in Safe Mode box is checked, here you can specify the Image Guardian Safe Mode level. Higher Safe Mode levels will result in a slower encryption process. The default Safe Mode level is 3.
You should increse the Safe Mode level in case you experience problems with the current Safe Mode level. In general, the slower your PC is, the higher Safe Mode level should be specified. Use Safe Mode level > = 6 for really slow machines (CPU speed < = 350 MHz, RAM < = 64 MB).
For faster machines(above 800 - 1000 MHz CPU speed), you may uncheck the Run Image Guardian in Safe Mode box (in this case the Safe Mode level setting value doesn't matter).
<<< Go Back <<<

Note: After you make whatever changes in Image Guardian configuration, you have to click 'Save settings' button to save them. Most of the configuration changes will have no effect before restarting HTML Guardian.
You can toggle Image Guardian OFF/ON and Image Guardian Safe Mode OFF/ON while HTML Guardian runs, but this will change those options only for the current session.
All the changes made in Image Guardian configuration will become effective after HTML Guardian is restarted.

Defining which images to be protected:
By default Image Guardian will protect all images in the html file bigger than the specified minimum image size, but there are several ways to define exactly which images to protect in case you don't want to protect all of them.

If you want to protect only let's say 2 images, cat.jpg and dog.gif, and leave the rest unprotected, include this html comment tag anywhere in the body of the html file:
<!--ig_include:cat.jpg;dog.gif -->
If you want to protect all images in the html file except cat.jpg and dog.gif, use the following comment tag:
<!--ig_exclude:cat.jpg;dog.gif -->
To disable Image Guardian for a specific file only, insert this tag in it:
<!--ig_disabled --> - no image will be protected even if Image Guardian is currently enabled.

These comment tags are CaSe SeNsItIvE and should be in lower case (except the image file names - they are not case sensitive).
Do not include path information, it's enough to include the file name only. Even if the relative path to a file is lets say Images\cat.jpg, it's enough to put in the comment tags cat.jpg only.
Of course you don't have to exclude files smaller than the specified minimum image size - they will be skipped automatically.

Go back

Image Guardian specifications and limitations - what it can and what it can't do

Accepted input file formats: *.jpg, *.gif, *.bmp - any image in another format (like *.png) will not be protected.

Output file format: always *.jpg No matter if the image to be protected is in jpg, gif or bmp format, it will be always divided into pieces saved in jpg format. The reason is gif format is patented and some legal issues may arise, and the bmp format is not widely supported by the browsers and is almost never used in websites. So Image Guardian provides a convenient way to use bmp files directly without having to convert them - it will do that for you.

Image Guardian can only protect images in html / shtml / php files. We plan to add Image Guardian support for .asp files soon.

Image Guardian can not be used when you use Ultra - Strong password protection.

At this time Image Guardian can only protect images inserted in the html document with the <IMG...> tag and with a relative path (image should be available locally).
Images included this way
<IMG src = "myimg.jpg"> <IMG src = "images/myimg.gif"> will be protected.
Images included this way
<IMG src = "http://www.mydomain.com/myimg.jpg"> will not be protected - Image Guardian will not download them from the web location, and it does not know where to look for them on the local hard drive

Background images and image maps will not be protected.
Animated *.gif files can be protected, but the animation will be lost. You can use the comment tags described above to tell Image Guardian not to protect them.

Any javascript functions triggered by image related events (onClick, onMouseOver etc) may not work. For example
<IMG src = "myimg.jpg" onClick = alert("Hi there")>
After the image is protected, no alert will be displayed when you click it.

Image alt attribute,if any, will be lost (alt is used to display a tooltip when the mouse is over the image, or to display some text in the place of the image if for some reason the image was not loaded).
<IMG src = "cat.jpg" alt = "My cat">

In most cases, protected images can't be manipulated through scripts. You can't have a rollover effect that uses protected images, to have a script that rotates several protected images, etc

Image Guardian may not protect the images in html files which contain a code that automatically redirects the browser to another file. This is a very rare situation though.
Any event driven redirections(like when a link is clicked) are not a problem.

Go back

Image Guardian and HTML Guardian Profiles & File lists

Image Guardian settings are not stored in HTML Guardian Profiles and File Lists. When you encrypt a file list, the current Image Guardian settings will be applied. This is the same for HTML Guardian profiles, any profile you load will use the currently specified Image Guardian settings.
At this time it is not possible to use a different predefined set of Image Guardian settings for each HTML Guardian profile or file list - always the current Image Guardian settings will be applied.

There are some things to consider when you encrypt filelists. Let's see an example:
You have added the following file to a filelist: C:\Test\index.htm
You have specified the encrypted version of this file to be saved as C:\Test\Encrypted\index.htm
In the Image Guardian settings window, you have specified the protected images to be stored in \e_imgs subfolder.
Lets say C:\Test\index.htm contains two images which are in the same folder, e.g.C:\Test
After you encrypt the filelist, the pieces of the protected images will be stored in C:\Test\e_imgs folder. But the encrypted file that uses them will be in C:\Test\Encrypted folder - this means the relative paths from the encrypted file to the protected images will be incorrect, and the images will not be displayed. You should cut the C:\Test\e_imgs folder and paste it inside C:\Test\Encrypted folder.
The same problem may appear if you encrypt a single file and decide to save the encrypted file in another folder(not where the original file is).
When you encrypt a folder or a site, HTML Guardian will first create a copy of this folder(site) and will encrypt the files inside that copied folder. All relative paths within that new folder will be correct and you don't have to do anything.

Go back

Image Guardian FAQ & Troubleshooting

Q: How to purchase Image Guardian?
A: You can't purchase Image Guardian standalone, it's an add-on to HTML Guardian.
To use Image Guardian, you have to purchase HTML Guardian Enterprise Edition.
In HTML Guardian Personal and Professional Edition the Image Guardian functionality is limited.

Q: My images are not protected. What's the problem?
A: First make sure that Image Guardian is enabled. Read carefully about the Image Guardian limitations.
Configure Image Guardian to run in Safe Mode.
Image Guardian will not protect an image in the following cases:
- image is smaller than the defined minimum image size.
- you specified that this image should not be protected.
- image is not included in the html file with the <IMG...> tag .
- image is included in the html file with an absolute path, like <IMG src = "http://www.mydomain.com/cat.jpg">.
- image is included in the html file with a relative path, but is not available at the specified location. If the image is included in the html file like <IMG src = "cat.jpg"> but the cat.jpg file is not available in the same folder where the html file is, it will of course remain unprotected.
- you are using HTML Guardian Personal Edition or HTML Guardian Professional Edition, where Image Guardian functionality is limited. Image Guardian is fully functional only in HTML Guardian Enterprise Edition.

If none of the above solves the problem, remove all empty spaces and special characters from image files names and from the names of the folders where the images reside. Let's see an example:
We have a .htm file in which we have included an image named my cat.gif, which resides in a subfolder named my pets.
So the IMG tag to display my cat.gif will look like

<IMG src='my pets/my cat.gif'>

Some HTML editors transform empty spaces and special characters, so in some cases the tag may look like

<IMG src='my%20pets/my%20cat.gif'>
 (the empty space is transformed to %20)

If this is the case, rename the folder my pets to my_pets or mypets
 Rename the file my cat.gif to my_cat.gif or mycat.gif
Update the html source so that the IMG tag points to the renamed file:
<IMG src='my_pets/my_cat.gif'>

Make sure the src attributes of all IMG tags do not contain empty spaces or special characters. We recommend to use only English letters (A-Z,a-z), numbers (0-9) and underscores (_) for file and folder names.

Q: I have the same image included in many files. If I use the random names option, will Image Guardian split this image into different pieces each time?
A: No. Image Guardian remembers the images protected in the current session, it will not generate new image pieces for an image that was already protected in the current session (after HTML Guardian was started) - it will use the existing, already generated pieces and the same encrypted code to display the protected image. But if you use the same image in let's say two files, you encrypt the first file, then you restart HTML Guardian and encrypt the second file, Image Guardian will generate new image pieces.
That's why it's recommended to encrypt all files of your site at once - this way you will avoid protecting some image several times.

Q: Sometimes the page layout changes and some page elements are transposed after I protect the images. Why is that and how to avoid it?
A: This could happen sometimes if you have two images next to one another like this

or an image with a text next to it, like this

This is some text next to the image

In most cases this can be fixed if you check "Enable smart detection" box.
Note that smart detection may remove empty spaces around the IMG tags. If this causes undesired changes in the page layout, replace empty spaces with a non-breaking space ( &nbsp; )
Like this: change <IMG src = 'cat.jpg'> This is my cat! to <IMG src = 'cat.jpg'>&nbsp;This is my cat!
If the results are not satisfactory, disable smart detection and follow the instructions below.

If the page layout changes ( in most cases the page element that is next to the image will go underneath the image after the image is protected ), you should put the page elements that you want to appear horizontally next to one another in a table. For the first example with the two images, the html code that displays them will normally look like:

<img src="dinosaur.jpg"><img src="leafs.jpg">

If you put those two images inside a table, the code to display them should look like

<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td><img src="dinosaur.jpg"></td>
<td><img src="leafs.jpg"></td>
</tr>
</table>

If you put the images to be protected inside a table ( which is a good practice anyway ), the page layout will not change and the page elements will not be transposed after the image protection.

Go back

Go back Next

© 1997-2003, ProtWare Inc. All rights reserved.

Enable Image Guardian Use random names Smart detection Protected images subfolder set minimum size How to split images Quality Run in safe mode


Known issues

Troubleshooting, known issues, problems and limitations

Quick Troubleshooter:

If you have problems with encrypted files, see if they match some of the problems described below. If yes, apply the suggested solution to fix the problem.

- In 99 % of the cases, the reason for the problem is the incorrect html syntax of the file to be encrypted. Read about syntax requirements here. The best way to find html syntax problems is to use some some html code validation tool. It will quickly find most errors, like unclosed tags, useless tags, missing tags etc.
HTML Guardian will inform you if it detects an incorrect html syntax in the files to be encrypted, but it can not detect the incorrect syntax in all cases.

- Change the Code Compression level and re-encrypt the file. You can do this from the General Settings window, or with CTRL+ALT+H (High compression) and CTRL+ALT+L (Low compression) shortcuts.

- Press F10 to load a blank profile and encrypt the file again.

- If you have problems with files encrypted for All browsers, change the All browsers encryption type and re-encrypt the file. You can change the All browsers encryption type permanently from the General Settings window, or use ALT+1, ALT+2 or ALT+3 shortcuts to apply encryption Type I, II or III respectively. If the "Automatically select encryption type" box is checked, you'll have to uncheck it first.

- If you have problems with files encrypted for IE 5+ and the Extensive Debugging option is turned Off, press F8 to turn it On and encrypt the file again(press F4 at any time to see the current status of the most important settings). You can also change this from the Advanced Settings window.

- If you see a blank browser window when testing the encrypted file on your PC, the reason is most likely you encrypted it with "Don't allow offline use / Domain Lock " and / or "Add referrer check" options - files encrypted with any of those options will not work offline.

- Files encrypted with Don't allow offline use will only work when uploaded to a web server (any web server, including a locally installed http server).
- Files encrypted with Domain Lock will work only on the web server they were locked to.
- Files encrypted with a Referer check can be opened only by clicking a link to them in another file, which is allowed to link the encrypted file. Such files can't be opened directly (by typing their URL in a browser, from the bookmarks etc.) or by clicking a link to them in another file which is not allowed to link to the encrypted file.

- For non - English websites, make sure you have the appropriate META tag that defines the character set to be used. It usually looks like
<meta http-equiv="Content-Type" content="text/html; charset=xxxxx">
where xxxxx defines the character set (encoding) needed.
Make sure such META tag is included in the HEAD section of your pages, preferably immediately after the <HEAD> tag.

View the Error Log. The most common problems HTML Guardian detects ( not all ) will be listed there. To view the error log click Tools --> View Error Log or press Ctrl + E - if nothing happens, Error Log is empty.
Each Error Log entry has the following structure:

Date & Time : Error status : File : Description

- Error status could be Problem or ERROR, depending on the severity of the error detected. Even if the status is ERROR, in many cases the file will work. However you should test all the files listed in the error log to see if the encrypted version of the file works as expected.
- File - the file where a problem was detected. Here you can see either the location of the original, unencrypted file, or the location of the encrypted file - check the encrypted file and fix the original if needed.
- Description - a short description of the problem detected.

Known issues:

Problems with folder encryption:

If you experience problems when you encrypt a folder ( with the 'Select Folder' button ), check the names of all files and folders inside the selected folder. If there are folder or file names which contain non-English characters or some characters that are unusual for folder/file names like = & . , ( ) [ ] { } , rename them.
In general we recommend that you use only English characters, numbers and underscores for folder and file names.

Problems with files which contain code that automatically redirects the browser:

There could be problems with html files which contain scripts that automatically redirect the browser to another location. For example, let's say you have a file test.htm that contains this script:
<script>document.location="new_test.htm"</script>
In this case the browser will be automatically redirected to new_test.htm, without fully loading or displaying test.htm
Another example - forcing files to load in frames, like:
<script>
if (parent.location.href == self.location.href){
self.location.href = 'Frameset.htm'
}
</script>
Actually this situation is the same as the above - the browser is automatically redirected to Frameset.htm.
It is not a problem at all to display the files in frames or to redirect the browser after the page was loaded(like when a button is clicked etc.). A problem may appear only if the browser is automatically redirected before the file was fully loaded.
Solution: In most cases HTML Guardian will handle such situations. But if you have problems with files that automatically redirect the browser, you should remove the redirection code, encrypt the file and then insert the redirection code back into the encrypted file (just after the <HEAD> tag).

Encrypted file does not work online:

Problem: Some encrypted files work fine offline but show errors online.
Solution: If the encrypted file works OK when you test it on your PC but it does not work when you try to open it from your web site, the reason could be this file was not fully uploaded.
Compare the file you have on your PC with the uploaded file you have on your server - there could be a difference(if all is OK, the size of both files should be the same, if not it will be different).
Some badly written ftp programs do not fully upload some files - for example some versions of Cute FTP(Pro). If you see that the file size of the uploaded file(on your server) is different from the file size of the locally stored file, try to upload the file again with another ftp program.

ASP files encryption:

The main problems in regard to asp files encryption are listed below without an explanation. For a detailed information, please read the "Protecting ASP files" section of the Help file.
- files used as includes must contain the <!--hgaspinclude --> comment tag.
- a non-encrypted asp file can not use encrypted includes (the opposite is possible, an encrypted asp file can use both encrypted and non-encrypted includes).
- in case of problems, switch between Standard and Enhanced ASP encryption.
- in case of problems, change the 'Auto-import ASP includes' setting.

Encryption of files which contain html / script code examples :

Problem: There may be errors in encrypted files which contain sample html and/or script code.
Solution: The best way to avoid such errors is to replace the html tag delimiters < and > with the corresponding html entities.
When creating pages with html/script code examples, always replace the html tag delimiters from the sample code with the corresponding html entities - do not use < or > - replace them with &lt; or &gt; in your source code.
In most cases HTML Guardian's Code Analyzer ™ engine will solve these problems even if you do not replace the tag delimiters in the sample code.
If however the pages are not displayed properly and you don't want to alter them, just increase the Code Analyzer's Heuristics Sensitivity Level from the advanced configuration settings window.
Heuristics Sensitivity Level should be set to 80 - 90 for encryption of files which contain html/script code examples.

Web counters:

Problem: Some web counters may become invisible after the page is encrypted.
Solution: There could be several reasons for that. One solution that will always solve this problem is to exclude the counter code from encryption, as described here.

Calling javascript functions from external .js files:

Problem: If you call a javascript function stored in a .js file from an encrypted html file, the function may not be executed.
Solution: A javascript function stored in a .js file may not work if called from encrypted html file, in case the function is called before the onLoad event fires for the encrypted html file that calls the function.
For example, let's see a simple html file named test.html that calls a simple .js file named myScript.js.
test.html file looks like:

<html>
<head>
<script language = 'javascript' src = 'myScript.js'>
//here we include the external .js file
</script>
<script language = 'javascript'>
myAlert = 'Hi there';
//here we call a function from the .js file
showalert(myAlert);
</script>
</head>
<body>
A simple test page
</body>
</html>

And myScript.js file looks like this:

function showalert(alert_to_show){
alert(alert_to_show);
};

In this simple example, the red line of code calls the showalert function before the test.html file is fully loaded. As a result, if you encrypt test.html(no matter if myScript.js is encrypted), no alert will be displayed. Instead, a javascript error may be reported by the browser.

There are several ways to fix this:

1. If the function is called after the onLoad event fires for test.html, like when a button is clicked, this problem will not appear.

In this case, test.html may will look like

<html>
<head>
<script language = 'javascript' src = 'myScript.js'>
//here we include the external .js file
</script>
<script language = 'javascript'>
myAlert = 'Hi there';
</script>
</head>
<body>
A simple test page
<form>
<input type="button" name="Button" value="ShowAlert" onClick=showalert(myAlert)>
</form>
</body>
</html>

2. You may include the .js file code in the .html file and not use an external .js file

In this case test.html with the .js file included in it will look like this:

<html>
<head>
<script language = 'javascript'>
function showalert(alert_to_show){
alert(alert_to_show);
};
</script>
<script language = 'javascript'>
myAlert = 'Hi there';
//here we call the function
showalert(myAlert);
</script>
</head>
<body>
A simple test page
</body>
</html>

3. You may use the partial encryption option(recommended).
Solution 1 may not be applicable in some cases. Solution 2 will work always, but if the .js file is big and is used from many .html files, it is not suitable.
You may also use HTML Guardian's powerful partial encryption capabilities and exclude the script tag that refers to the external .js file from encryption. In this case, the test.html file will look like:

<html>
<head>
<!--htmlgskipstart -->
<script language = 'javascript' src = 'myScript.js'>
//here we include the external .js file
//but the script tag is excluded from encryption
</script>
<!--htmlgskipstop -->
<script language = 'javascript'>
myAlert = 'Hi there';
//here we call a function from the .js file
showalert(myAlert);
</script>
</head>
<body>
A simple test page
</body>
</html>


HTML Guardian Help

Intro

What is HTML Guardian

How to purchase HTML Guardian Professional or Enterprise

Features

How to use HTML Guardian

FAQ

File List Manager and Command line reference

Site Manager

General settings

Profiles and advanced settings

Image Guardian - how to protect your images

Protecting ASP files

Ultra - Strong password protection

Protecting Style Sheets (.css)

Protecting PHP files

Known issues & Troubleshooting

Support

Contact

Shortcuts

History


Image protection - protect images

How to protect a single image or the images in a folder ?

Image Guardian can not protect stand-alone image files (.jpg / .gif / .bmp) - it can only protect the images included in html files together with encrypting the html source of the page that uses the images. But in some cases, like for example in many image gallery type of websites, images are not included in any html file but are dynamically loaded through client or server-side scripts, from databases etc.

To make possible protection of images not included in existing html files, HTML Guardian can generate a html file that displays the image automatically, based on templates. You can protect either a single image file, or all the images in a given folder.

To protect a single image file, click Tools --> Protect Single Image, or press Shift + F1.
To protect all the image files in a folder, click Tools --> Protect Images Folder, or press Shift + F2.

HTML Guardian will automatically generate a html file that displays the image to be protected from a template, and will encrypt this file and protect the image it displays. Then, you may display those html files in an IFRAME, in another frame, or in a javascript generated window. This eliminates the main disadvantage of the protected images - that they can't be manipulated through scripts. Automatically generated html files that display the protected images can be easily manipulated with simple scripts - for example, in the template file you may include Previous and Next buttons your visitors may use to navigate through your image gallery, insert a code that will display a random protected image etc.

Using templates:
When you select to protect an image or an images folder, HTML Guardian will first generate a html file to display the image to be protected from a template .htm file.

This template file should be named i_t.htm and should contain the following tag:
<img src = 'protected.jpg'>

The <img src = 'protected.jpg'> tag should not contain width and height attributes, unless all the images to be protected using this template have the same width / height It's the same for all the other attributes an IMG tag may have - like align etc. - use them only if all the images to be protected using this template will have the same attribute value.

HTML Guardian will replace protected.jpg with the name of the image to be protected (it doesn't matter that the image file may have another extension like .gif or .bmp), will generate a new .htm file that displays the image, and will encrypt this file and protect the image in it automatically. The generated .htm file will be named image_name.htm. If you selected to protect the my_cat.gif image file, HTML Guardian will automatically create a file named my_cat.htm file that displays mycat.gif, and will encrypt my_cat.htm file using the currently specified Image Guardian settings to protect my_cat.gif.
The pieces of the protected image will be stored in a subfolder of the folder where the original image resides. The name of this subfolder will be taken from the Image Guardian configuration settings (the name used will be the name specified in the 'Put protected images in xxxxx subfolder' in the Image Guardian configuration settings window).

HTML Guardian will first search for a template file named i_t.htm in the folder where the image to be protected is. If there is no such file, it will search for a template file named i_t.htm in its installation folder (most likely C:\Program Files\HTML Guardian). If there is no such file, it will use a simple generic template file to display the image.
This means you can use a custom, individual template for protecting the images in each folder. If the file where the image is does not contain a template file named i_t.htm, the common template file named i_t.htm in program's installation folder will be used. If the program's installation folder does not contain a file named i_t.htm, a simple generic template (built in HTML Guardian) will be used.

Some notes about templates:
- the template file may contain other, additional IMG tags, not only the <img src = 'protected.jpg'> IMG tag. For example, it may contain images that work like Previous and Next navigation buttons, your company logo image etc. But those additional images will not be protected.
- do NOT put any of the ImageGuardian control comment tags ( <!--ig_include:... --> , <!--ig_exclude:... --> , <!--ig_disabled --> ) in the template file - this may have unexpected results.

Protecting all the images in a folder:
If you select Tools --> Protect Images Folder, or press Shift + F2, a 'Select Folder' dialog will appear. When you select the folder for which you want to protect the images, HTML Guardian will proceed as follows:

(let's say you selected the C:\Test\ folder )

- it will copy all the .jpg / .gif / .bmp images from C:\Test\ to a new folder named C:\Test_I\
- it will create a new .htm file for each image to be protected inside C:\Test_I\
- all the .htm files created inside C:\Test_I\ will be encrypted, using the currently specified ImageGuardian settings.
- the original images will be deleted from C:\Test_I\ , only the protected ones will remain.

Note:
- ImageGuardian will be enabled automatically when you select to protect a single image or an images folder.

- protecting the images in a folder is not recursive - the images inside the subfolders of the selected folder, if any, will not be protected.

- If you are using the HTML Guardian Personal or Professional edition, all the ImageGuardian limitations remain. If the image file to be protected does not comply with those limitations, it will not be protected - only the file that displays the image will be encrypted.
In such case, the image will not be visible if you open the encrypted .htm file that displays it , because the original image will not be available in the same folder, and a protected image will not be available either. If you copy the original image to the same folder, it will be displayed in the encrypted .htm file.
Please test the image protection features only with images that comply with the ImageGuardian limitations, if you are using the Personal or the Professional edition of the program.


HTML Guardian advanced settings

HTML Guardian Profiles and advanced configuration settings

HTML Guardian's Profile Manager and Advanced Configuration Settings window can be invoked from the Configuration menu or by pressing the F5 key.

Here you can configure HTML Guardian Profiles and Advanced Settings for the Code Analyzer engine, Encryption engine and Debugging engine.

A profile is a predefined set of protection options and settings for the Code Analyzer, Encryption and Debugging engines. When you load a profile, all settings stored in it will be automatically applied to all files encrypted after the profile was loaded.
Profiles provide a convenient way to quickly apply a set of settings without having to specify them for each file individually. However, you may change each profile setting before encrypting some file.
Let's say the currently loaded profile is set to disable the text selection - this protection option will be automatically applied to all files. But you may uncheck the 'Disable text selection' box before encrypting some file, and this option will not be applied to it. For the next file you encrypt, it will be applied again.

Default settings Tab
Profiles Tab
IE 5+ Tab
Noscript Tab
Code Analyzer Engine Tab
Profiles and File Lists

Default settings Tab

In the Default settings Tab you can configure the protection options to be used for a certain profile. You can specify different options for html/shtml, script and frameset files. Here you can also define the default browser for this profile, the password protection and the referrer check.
Only one password and one referrer can be set for a given profile. Also, only one wrong password action and only one wrong referrer action can be defined per profile.

Go back

Profiles Tab

The Profiles Tab let's you manage your profiles.

Load selected profile button will load the profile selected in the Available profiles list. All files encrypted afterwards will be encrypted with the settings from this profile.

Set selected profile as default button will make the profile selected in the Available profiles list the default one (but will not load it).

Load blank profile button will load a profile with a minimum set of options - files will be encrypted without any additional protection options, and all settings for the Code Analyzer, Encryption and Debugging engines will be set to their minimum values. This can be useful for identifying problems - if the encrypted file does not work as expected, you may load a blank profile and try again.
You can load a blank profile at any time by pressing the F10 key.
Unlike all other profiles, the blank profile (blank.hgp) can't be modified.

Load Default profile when HTML Guardian starts - if checked, the profile set as default will be automatically loaded when the program starts, and all files will be encrypted with the settings from this profile(unless you load another profile). If not checked, and you do not load another profile, all files will be encrypted using the default HTML Guardian settings.

To create a new profile, click the Create a new profile from the current settings button. You will have to specify a name for the new profile, and all the settings specified in all tabs will be saved as a new profile. To be able to use the new profile, click the Refresh button - the new profile will appear in the Available profiles list, and you will be able to load it or set it as a default profile.
If you modify the currently loaded profile and save it under the same name, you will have to load it again for the changes to become effective.

Note : Files will always be encrypted with the settings specified in the currently loaded profile.
If you check the Load Default profile when HTML Guardian starts box, this will load the default profile at startup, and all files will be encrypted with the settings specified in it (unless you load another profile).
If no profile is loaded (Load Default profile when HTML Guardian starts box is not checked), HTML Guardian will apply its default settings, not the settings specified in the default profile.
Note that the default HTML Guardian settings (which will be applied if no profile is loaded) are different from the settings specified in the blank profile (blank.hgp)
The currently loaded profile is displayed under the Available profiles list. If you see there Default profile: None this means no profile is currently loaded and the default HTML Guardian settings will be applied.

Press F4 to see the current values of some of the most important settings.

Go back

IE 5+ Tab

Here you can specify some settings for the files encrypted with the alternative encryption method (for IE 5+ only).
All these settings will have no effect for files encrypted with the default (for All browsers) method.

Put a browser detection script in html files encrypted for IE 5+ - if this option is checked, a script for browser detection will be inserted in all html files encrypted for IE 5+.
If a page encrypted for IE 5+ is loaded in another browser, it will not be displayed properly ( in most cases a blank page will be displayed ) . Using this option, you may show a message to the visitor that IE 5+ is needed to view this page, to redirect him to another page etc, depending on the script.
The script itself is stored in ie5script.txt file in HTML Guardian's installation folder, clicking the Edit button will open this file for editing.
The script tags must be included, i.e. the ie5script.txt should start with <script> and end with </script>.

Note that HTML Guardian may reject the script - in such case no error message will be displayed, the script will simply not be included in encrypted files.

Default IE 5+ encryption method - it is recommended that you use the Enhanced method. In case of problems with encrypted files you may switch to the Classic method.
You may change the Default IE 5+ encryption method at any time by pressing the F6 key (to apply the Classic method) or F7 key ( to apply the Enhanced method ).
If you use F6 or F7, this setting will remain valid for the current session (i.e. until you restart HTML Guardian), no matter of the setting specified in the currently loaded profile. For example, the currently loaded profile may be set to use the Enhanced method. If you press F6 (to switch to the Classic method), all files will be encrypted using the Classic method afterwards - but this will not alter the profile.

Extensive debugging - in most cases there is no need to use this option, but if the encrypted file does not work as expected, you should turn it on. You can turn Extensive Debugging On at any time by pressing the F8 key, or turn it Off by pressing F9.

Press F4 to see the current values of some of the most important settings.

Go back

Noscript Tab

Files protected with HTML Guardian can only be viewed in a javascript enabled browsers. Although 99.9 % of the browsers used these days are javascript enabled, there is still a small possibility someone with a non-javascript enabled browser to visit your site - in such case, only the content of the NOSCRIPT tag will be displayed.
You can put any valid piece of html code inside the NOSCRIPT tag ( of course no scripts ). The NOSCRIPT tag to be inserted is stored in the noscript.txt file in HTML Guardian's installation folder, click Edit to modify it. NOSCRIPT tags should be included, i.e. this file should start with <NOSCRIPT> and end with </NOSCRIPT>.
It is recommended to insert a NOSCRIPT tag in encrypted HTML formatted emails - in some email clients javascript is disabled. In the NOSCRIPT tag you may also include a content which you want the search engines to see but to remain invisible to the visitors of your site.

Note that HTML Guardian may reject the NOSCRIPT tag - in such case no error message will be displayed, the NOSCRIPT tag will simply not be included in encrypted files.

Go back

Code Analyzer Engine Tab

Here you can define some Code Analyzer engine settings

The Heuristics Sensitivity Level setting basically defines how deep should Code Analyzer look in your code to predict possible conflicts and problems. For most files the recommended setting is between 50 and 60.
It is recommended to increase the Heuristics Sensitivity Level in the following cases:
- files with complicated scripts and dhtml effects
- files which contain sample html or script code, such as tutorials on web design etc.
- files that use document.write and similar statements to dynamically change the page code
- files where complicated javascript functions are called when some event fires, for example a button click - in this case the Code Analyzer engine will try to predict what will happen with the encrypted page if some event fires.
For simple files you may decrease the Heuristics Sensitivity Level

Allow Code Analyzer to change Heuristics Level if necessary - there are many situations available in Code Analyzer's knowledge base for which a certain Heuristics Level is the most suitable. If this option is checked and such situation occurs, the Code Analyzer engine will automatically switch to another Heuristics Level, known to handle such situation better. This will only be done for the file currently being encrypted, then the Heuristics Level will be restored to the value specified in the currently loaded profile.
If this option is checked, in most cases there is no need to change the default Heuristics Level in your profiles - the Code Analyzer will change it if needed.
We recommend that you always use this feature.

Allow Code Analyzer to interact with installed browsers - if checked, the Code Analyzer engine will test a 'suspicious' parts of the code to see how they will behave in different browsers after encryption by checking each browser reaction to them.
Code Analyzer can test the behavior of IE4.0 or higher, Netscape 4.0 or higher and Opera 5.0 or higher. Of course, it can only test those browsers which are installed on your system. That's why we recommend that you have at least one version of IE, Netscape and Opera installed. For Netscape and Opera, it is not a problem to have different versions installed.
We recommend that you use this option, although it may slow down the encryption a bit.

Launch multiple instances of Code Analyzer for encryption of folders or filelists - if checked, this will launch a separate instance of the Code Analyzer engine for each file that has to be encrypted. This means also a separate instance of the Encryption and Debugging engines will be launched for each file.
This option can only be useful if the total file size of the files to be encrypted at once exceeds 2-3MB, otherwise there will be no noticeable difference in encryption speed. But if you need to encrypt a large amount of files at once often, it can be very useful - our tests with a 40MB set of files showed nearly 5 times faster encryption if this option is used.
In most cases, there is no need to use this option. It should not be used for PC's with less than 128MB RAM.

Go back

Profiles and File Lists

When you encrypt a File List or a Site, all settings specified in the currently loaded profile will be applied to the files in the list / site, except those specified in the Default Settings tab - in file lists / sites these settings can be specified for each file individually, so the profile settings will be ignored. If no profile is loaded, the default HTML Guardian settings will be applied for all the options that can't be configured from the File List Manager / Site Manager.

Go back


HTML Guardian history

HTML Guardian Keyboard shortcuts

F1 | - display Help file
F3 | - open the General settings window
F4 | - display information about the current settings
F5 | - open the Profiles & Advanced settings window
F6 | - switch to Classic encryption method for IE5+ browsers
F7 | - switch to Enhanced encryption method for IE5+ browsers
F8 | - turn Extensive debugging ON
F9 | - turn Extensive debugging OFF
F10 | - load a blank profile
ALT + 1 | - switch to type I encryption method for All browsers
ALT + 2 | - switch to type II encryption method for All browsers
ALT + 3 | - switch to type III encryption method for All browsers
CTRL + 1 .. CTRL + 4 | - test the encrypted file in defined browsers 1 .. 4
CTRL + B | - open the browsers configuration window
CTRL + E | - view the Error log
CTRL + I | - open the Image Guardian configuration window
CTRL + K | - clear the Error log
CTRL + L | - open the File List Manager
CTRL + R | - open the Site Manager
CTRL + U | - open the Ultra - strong Password Protection Utility
CTRL + ALT + A | - toggle ASP client side code response encryption
CTRL + ALT + D | - toggle Image Guardian Smart Detection
CTRL + ALT + H | - switch to High Code Compression level
CTRL + ALT + I | - toggle Image Guardian On / Off
CTRL + ALT + L | - switch to Low Code Compression level
CTRL + ALT + S | - toggle Image Guardian Safe Mode


HTML Guardian Site Manager

HTML Guardian's Site Manager

The Site Manager is a tool that allows you to encrypt entire web sites with just a few clicks.
You only have to configure the settings for a given site once and then you can encrypt it in seconds each time you make some changes.

To open the Site Manager, click 'Site Manager' under the 'Tools' menu, or press Ctrl + R

How the Site Manager works:
When you encrypt some site, the Site Manager will create a new folder to store the encrypted site files. Inside that folder the Site Manager will create two separate encrypted copies of the original site - one encrypted for 'All' browsers, and the other encrypted for 'IE 5+' browsers - each copy will be in a separate subfolder. A new index file that detects the browser type and redirects the visitor to the appropriate encrypted copy of the site will be generated automatically.
All the files from the site root folder will be copied to the encrypted site folder, even the files which HTML Guardian can not process (flash animations, sound files etc.).
The reason to have two encrypted copies of the site is simple. If you want your encrypted site to be compatible with any browser, you'll have to use the default encryption method for 'All' browsers. On the other hand, the 'IE 5+' encryption method is better and faster, and now more than 90% of web surfers use IE 5.0 or higher browser. When you have two encrypted copies of the site, IE 5+ browsers will be redirected to the copy encrypted specifically for them, and the rest will be redirected to the other copy - this ensures the best possible performance.

The Site Manager window has 3 main parts:
- Files settings (at the top) - here you can specify the protection options for each file individually.

To change / edit some option, just double click the appropriate cell.
Click Add File(s) to add new files to the site, for example files created after the site was defined. You can only add files which reside inside the site root folder.
Hold down Ctrl or Shift keys to add multiple files at once.
Click Remove File to remove a file from the site. If you remove a file, it will not be encrypted. The original, unencrypted file will be copied to the folder where the encrypted site is stored.
Click Apply settings to all files to apply the settings for the currently selected file to all other files.
Click Save Site Settings to save the current site configuration. It will be saved in a file with a .hgs extension in HTML Guardian's installation folder.
Click Encrypt Site to encrypt the site. Depending on the site size this may take some time, especially if Image Guardian is enabled - it may even look like the program is not responding. Please wait until you see a message that the encryption is finished.

Defined sites (bottom left) - here you can open existing sites, create new ones or delete sites.

In the Defined Sites list you can see all the sites you have already defined.
Select one of them and click Load Site to open it for editing and / or encryption.
To create a new site, click New Site. You have to configure the following parameters:
- Site root folder - the folder where all files that belong to that site reside. Only files inside that folder are considered a part of the site.
- Site name - any name of your choice.
- The main file for the site - this is the file that the visitors of your site will see if they type in the browser's address bar only your domain without specifying a file. If for example you type in your browser http://www.protware.com, you will see http://www.protware.com/default.htm file - default.htm is the main file for our site. The main file is usually named default.htm(l) or index.htm(l).
After you configure these settings, all appropriate files from the selected Site root folder will be displayed in the Files settings list. You have to configure the protection options for each file and then save the site configuration - that's all, the site is ready for encryption.
Click Delete Site to remove a site from the list. The only thing that will be deleted is the site definition file stored in HTML Guardian's installation folder. No other file will be deleted.

Site settings(bottom right) - Displays information about the settings of the currently loaded site.

Site name - any name of your choice
Site main file - here you have to select the main file of the site from the list of all files
Names of the subfolders to store encrypted files - here you can specify the name of the subfolder where the files encrypted for 'All' browsers will be stored and the name of the subfolder where the files encrypted for 'IE 5+' browsers will be stored.
Encrypted site will be saved in: - The folder where encrypted site will be saved. This folder can't be changed. It will be at the same folder level as the site root folder and its name will be the the site root folder name with _E added at the end. If for example the site root folder is C:\MySites\Test\, the encrypted site will be saved in C:\MySites\Test_E\
Note: If the folder where the encrypted site will be saved exists, it will be deleted when you click the Encrypt Site button and then it will be recreated again. You should not edit the files there or add new ones because they will deleted the next time you encrypt the site.
Apply IE 5+ specific protection options only to files encrypted for IE 5+ browsers - the 'Disable Clipboard & PrintScreen' option will only work for IE 5+ browsers. If this box is checked, this protection option will be applied only to the files encrypted for IE 5+.

Customize browser layout section - here you can define exactly how the browser window your site will be opened in will look like. By removing some of the default browser layout elements you can get some more screen space for your site, and you may limit visitors access to browser menus.

Enable Address(URL) bar - if checked, the browser's address bar will be visible (this is the field where you can see the address of the currently loaded page, or to type a new address to be visited).
Enable Menu bar - if checked, the browser's Menu bar will be visible (the one with the File, Edit, View etc. menus).
Enable Tool bar - if checked, the browser's Tool bar will be visible (the one with the Back, Forward, Stop, Refresh, Print etc. buttons).
Enable Status bar - if checked, the browser's status bar will be visible (this one is usually at the bottom of the browser window. When you move the mouse over some link, you can see where this link points to in the status bar).

If all the above four options are checked, Customized Browser Layout will not be used because this is the same as the default browser layout - in this case your settings will be ignored, and the site will be encrypted as if the 'Customize browser layout' box was not checked.

FullScreen Mode - if checked, the browser will attempt to maximize your site as much as possible, getting all the screen space available. Fullscreen mode implementation varies across different browsers and even across different versions, builds etc. In most cases for IE 5+ browsers, opening your site in FullScreen mode will hide the browser's Title bar and the visitors will not be able to minimize the browser window from the '_' button or close it from the 'X' button(closing the site may only be possible from the Task Manager).
Some notes about Customized Browser Layout:
Customized Browser Layout will not be applied for Netscape 4.x browsers - this means any settings specified in the 'Customize Browser Layout' section will not be applied if the site is visited with a Netscape 4.x browser. The reason is the javascript engine of Netscape 4.x is really bad(least to say) and this may cause a browser crash on less stable systems(like Windows 9x/ME).
If you want, you can deny access to your site for certain browsers as described here.

You should not use the so-called 'framebuster' scripts if you use Customized Browser Layout. These are scripts that check if the file is opened in a frameset and remove the frameset(replace it with the file itself).

It will not be possible to open files that are a part of a site protected with a Customized Browser Layout option in a new browser window because the new window will be with the default browser layout, not with the one specified by you.
If you want some of the files to be opened in a new browser window, you should remove them from the site - they will be copied to the encrypted site folder unmodified. You can then encrypt them separately. Such files will be opened in a new browser window with the default browser layout.

Sites with customized browser layout should always be encrypted entirely. If you modify some of your original html files, you should then re-encrypt and upload again the entire site, not the modified file only (if you modify an asp or a script(.js / .vbs) file, you don't have to re-encrypt and reupload the entire site).

Uploading the encrypted site to your server

The folder where the encrypted site is saved will have one html file and two subfolders inside.
(If you used Customized Browser Layout, it will have 3 html files and two subfolders inside)

You should upload the html file(s) and the two subfolders to the root folder of your server.
- In case Customized Browser Layout was NOT used:
The html file is the new main page of your site. It will have the same name as the file you specified as a main file for the site in the Site Settings, but it will not be the same file. It will only detect the browser type and will redirect the visitor to the appropriate encrypted copy of the site. This file is not encrypted and you can edit it.
If you want, you can encrypt it before uploading the site - but you must encrypt it for 'All' browsers. There is no sense to use any of the additional protection options for this file, especially you should not use the 'Referrer check' option.
- In case Customized Browser Layout was used:
Everything is the almost same as before - one of the 3 html files is the new main page of your site. It will have the same name as the file you specified as a main file for the site in the Site Settings, but it will not be the same file. In this case this file will be encrypted. The other two files (they will have random meaningless names) are created by the Site Manager and should not be modified in any way, you just have to upload them to the root folder of your server.

Important Note:
There could be many cases when someone may try to open a file encrypted for IE 5+ browsers with IE4, Netscape, Opera etc., or to open a file encrypted for All browsers with IE 5+. If the visitors start to browse your site from the main page this can't happen - they will be redirected to the appropriate encrypted version of the site automatically. But this could happen if they go directly to some of your pages (from bookmarks, from a link posted on another site etc.).
To prevent opening the encrypted files in an unsuitable browser, the Site Manager inserts browser detection & redirection code in each encrypted page. If the browser type and the encryption method do not match, the visitor will be redirected to the main page.
Please take the above note into consideration when you test the encrypted site:
- if you try to open any file encrypted for 'All' browsers with IE 5+, you'll always be redirected to the main page of the copy of the site encrypted for IE 5+
- if you try to open any file encrypted for 'IE 5+' browsers with IE 4, Netscape, Opera etc., you'll always be redirected to the main page of the copy of the site encrypted for All browsers
This may look like a bug when you test the site, but it's not - this simply ensures that no file will be loaded in an unsuitable browser .

Using the Site Manager with Image Guardian

Image Guardian settings are not stored in the site definition files. This means the images used in the currently loaded site will be protected if Image Guardian is enabled, using the currently specified Image Guardian settings. Your original images will not be copied to the encrypted site folder, only the protected ones will be.
If Image Guardian is not enabled, images will not be protected - they will be copied to the encrypted site folder unmodified.

Using the Site Manager with Profiles

All the settings from the currently loaded profile, except the ones specified in the 'Default settings' tab, will be applied to the files that belong to the currently encrypted site.
All the settings specified in the 'Default settings' tab for the currently loaded profile will be ignored when you encrypt a site - the settings specified for each file in the site definition file will be used instead.
If no profile is loaded when you encrypt a site, the default HTML Guardian settings will be applied for all the options that can't be configured from the Site Manager.


HTML Guardian support

Please note: We only provide technical support in English. Any support requests in other languages will not be answered.

System requirements:
OS: Windows95/98/Me/NT/2000/XP
Hardware: 486 or better CPU, 16 MB RAM

Although not absolutely necessary, it is highly recommended that you have all target browsers installed on your system. In the process of debugging the encrypted page CodeAnalyzer™ engine and the debugging engines may need to interact with them if a situation not found in their database occurs.
CodeAnalyzer's database is constantly being updated and improved, so in 99% of the cases your files will be correctly encrypted even if you don't have any browser installed. But if you have them, this percentage will slightly increase (to 100% :)

Supported browsers: please see our FAQ

Syntax requirements for HTML files: To ensure proper encryption, your files should comply with some very basic and simple syntax requirements. Html files should always have opening and closing html, head and body tag. Frameset files should always have opening and closing html and head tag and should not have a body tag. There should be no code outside the head or body.
In many cases files which don't comply with the above will be displayed by browsers without errors, but HTML Guardian needs these requirements to be fulfilled.

Before contacting our support team please ensure files you have problems with comply with the above!
We receive a big amount of support requests for non-working encrypted files and the reason in 99% of the cases is the improper syntax of the original file.
Example of a file with a valid syntax:
<html>
<head>
..head content comes here..
</head>
<body>
..body content comes here..
</body>
</html>

The most common cases of improper syntax are files in which one or more of the
<html> , </html> , <head> , </head> , <body> , </body>
tags is missing, or is not in the right place(for example <body> is before </head>).
Another common source of problems is putting code outside the <head>...</head> and <body>....</body> tags, for example:
<html>
<!--There should be no code here, even comments -->
<head>
..head content comes here..
</head>
<!--There should be no code here, even comments -->
<body>
..body content comes here..
</body>
</html>

Incorrect html and script comments may also cause problems:
A correct html comment looks like this <!--some comment -->
There should be no space after <!--, and there should be one space before -->
There should be no html comments inside script tags (except the commonly used <!-- at the beginning of the script and //--> at the end to hide the script from old browsers - but they are useless if you intend to encrypt the file, and browsers for which this is needed practically do not exist anymore - so you better don't put <!-- .... //--> in scripts at all).

Contacting technical support:
To contact our support team, please mail to support@protware.com. Your will receive a reply typically within one business day, but in many cases faster.
Problems with encrypted files:
If you have problems with the encrypted files, please before contacting our support read our FAQ and the 'Known Issues' section of the Help file and ensure that you have the latest version of HTML Guardian. The latest version available is always listed on our website, and you can see your version by clicking 'About' in the Help menu.
To be able to help, we will need to reproduce your problem. So please zip and send us the file(of course, unencrypted:) that causes the problem together with all the files referenced in it(images, script files, applets, etc). Please also provide the following information:
- a brief description of the problem
- protection options used
- your operating system
- in what browser the problem appears - if the problem only appears when you open the file with a specific browser, please tell us the name, version, built, etc. Also, is this browser installed on the computer where you encrypted the file.

Plain text files (like html, scripts, css, asp etc.) are often altered when sent as email attachments. That's why we kindly ask you always to send us whatever attached files zipped - we need to be sure we are testing exactly the same files as you.

Please do NOT send us files which we can't test - for example .asp files that connect to databases.

We will use your files for debugging only and will delete them after the problem is identified.
Please direct your questions regarding beta versions of our products to betatest@protware.com.
Please do not send encrypted files asking us to restore the original. We can't do that.


How to use HTML Guardian

You need to follow four easy steps to protect your files with HTML Guardian.
  • Select the file(s) to protect

    • Click 'Select file' if you want to encrypt a single file.

    Click 'Select folder' to encrypt all files in that folder at once. Only *.htm, *.html, *.shtm, *.shtml, *.stn, *.js, *.vbs and *.asp files inside the selected folder will be encrypted, everything else will remain unchanged (if Image Guardian is enabled, images will also be protected).
    When you encrypt a folder, HTML Guardian will create a copy of this folder with "_E" added to the folder name and will put all encrypted files there under their original names. If for example you selected to encrypt C:\MySites\Site1\ folder(the source folder), the encrypted files will be saved in C:\MySites\Site1_E\ (the destination folder).
    HTML Guardian will copy all the files that were not encrypted(like .swf etc) , and all subfolders from the source to the destination folder too to ensure that encrypted files will work correctly.
    Actually the destination folder will be an exact copy of the source folder. Files of types which HTML Guardian can't protect will be copied to the destination folder unmodified.
    Note that folder encryption is now recursive - HTML Guardian will encrypt all appropriate files in the source folder, and all files inside its subfolders.

    Click 'Paste' to paste code for encryption from the clipboard.

    For fast and easy encryption of custom sets of files with different protection options for each file, please read HTML Guardian's File List Manager and Command line reference.

    To encrypt an entire website (or any set of files that reside in one folder) both for 'All' and 'IE5+' browsers with different protection options for each file, use HTML Guardian's Site Manager.

  • Set the desired protection options

    • All HTML Guardian protection options and settings are explained below.
    If you want to protect the images in the files you encrypt, you should also enable and configure Image Guardian.

  • Encrypt the file(s)

    • That's really easy, just click 'Encrypt'.

  • Test & Save the result

    • Once the file(s) are encrypted, test the result. If you selected to encrypt a single file, just click the 'Test' button to open the encrypted file in your default browser. Note that it is disabled if you've selected to encrypt a script file, or if you've checked 'Don't allow offline use' option, or if you encrypt an .asp file.
    For script files, test all html files that use them. If you saved the encrypted script file under a different name, don't forget to change that name in the html files that use the script file before testing.
    Files with offline use disabled will not work if you simply double click them in windows explorer. You have to open them using the http protocol - either upload them to some web server, or test them using a local http server(this also applies to .asp files). Windows NT/2000 users may use Microsoft's one which is a part of IIS(Internet Information Services). Windows 9x users may use Microsoft's Personal Web Server, or some other http server like OmniHttpd. To test a file using a local http server, just copy the file to the server's root folder, then in the URL field of your browser type http://127.0.0.1/filename.htm.

    You can define up to 4 browsers in which you want to test the encrypted files by clicking 'Define browsers' under the 'Tools' menu (or by pressing Ctrl + B). Click the "..." button to select the main browser executable.
    After the browsers are defined, you can test each encrypted file in each of the defined browsers by pressing Ctrl + 1 .... Ctrl +4 keys. This is only possible if you encrypted a single file, testing encrypted folders, sites or filelists in diferrent browsers should be done manually.

Setting the protection options

  • Target browsers

    • Here you have to define in which browsers the encrypted file should work.
    If you select 'All', the encrypted file will work in all javascript enabled browsers.
    If you select 'IE5+', encrypted files will be properly displayed only in Internet Explorer 5.0 or higher, and also in all browser built on Internet Explorer, such as NetCaptor, FastBrowser, ClickGarden, etc.
    The second method is faster and more secure, it's practically impossible to be cracked. A comparison and some suggestions about which method to use you can read here.

  • File type

    • You only need to set this option if you paste code for encryption from the clipboard. In all other cases HTML Guardian will detect it automatically.

  • Encrypting only some parts of the file

    • This option can't be configured from the user interface.
    There are two possible ways to encrypt a file partially:
    You can specify which parts of the code TO BE encrypted (the rest of the code will remain unencrypted)
    - - OR - -
    You can specify which parts of the code NOT TO BE encrypted(these parts will remain unencrypted, the rest of the code will be encrypted)
    If you want to encrypt only a part of the code, you have to enclose it within these html comment tags(case sensitive):

    <!--htmlgstart -->
    ... here comes the part of the code you want to encrypt
    <!--htmlgstop -->

    If you want some part of the code to remain unencrypted, you have to enclose it within these html comment tags(case sensitive):

    <!--htmlgskipstart -->
    ... here comes the part of the code you do not want to encrypt
    <!--htmlgskipstop -->

    If HTML Guardian founds these tags in the file to be encrypted, it will automatically switch to partial encryption mode, otherwise it will encrypt the entire file. Partial encryption is only possible for html files, and not for script, frameset, .shtml or .asp files.
    You can encrypt or leave unencrypted as many parts of the code as you wish, but you can't mix both methods in one file. Read some more details here.

  • Disable right click

    • This option is very useful and we suggest that you use it for all html files. This way the visitors of your site will not be able to right click on your images and select 'Save image..' from the context menu, or to copy link addresses the same way.
    Using this option will also automatically disable the Image Toolbar in Internet Explorer 6.

  • Don't show links in status bar

    • Normally when you put your mouse over a link, the file to which this link points is displayed in browser's status bar(usually at the bottom of the browser window). Check this option if you don't want this information to be visible. Use this option together with the previous one, otherwise visitors will be able to copy link addresses from the right click context menu
    Note: This option will suppress your custom status bar messages, if any.

  • Disable text selection

    • Using this option will make impossible text to be selected and copied by dragging the mouse, pressing Ctrl+A or clicking 'Select All' either in browser's Edit menu or in right click context menu.

  • Don't allow offline use / Domain Lock

    • These are actually two different (although similar) protection options, and it is possible to choose which one (Don't allow offline use or Domain Lock) to be applied when this box is checked.
    You can select which option to be used in the General Settings configuration window, by checking or unchecking the 'Use Domain Lock instead of 'Don't allow offline use' box.

    If you choose to use the 'Don't allow offline use' option, your files will work fine when someone is browsing your site, but will not work if they are saved and run from a local hard drive. To work, files protected this way should be requested through http protocol. To test a file with offline use disabled, you have to upload it to some web server, or you can also test it offline if you have some http server installed, like the http server which is a part of Microsoft IIS(Internet Information Services). The file will not work if you simply double click it .To test the file using a local http server, copy it to the server's root folder, then in the url field of your browser type: http://127.0.0.1/filename.htm

    If you choose to use 'Domain Lock' option, encrypted files will work only if requested from your domain - they will not work offline, and will not work if uploaded to any web server except yours. Note that there is no way to test such files on your PC, even through a local http server.

  • Password protection

    • When you check 'Password protect this page' box, the password configuration window will open. Here you have to set the password which the visitors must enter to see the page. Also, you have to select where to redirect the visitors in case an incorrect password was entered.
    Redirection options are:
    Display blank page - will display a blank page.
    Go back - will turn the visitor back to the previous page visited.
    Redirect to this URL - here you can enter any valid URL like http://www.protware.com - visitor will be redirected to this url in case of incorrect password.

    If you want to password protect many files but the visitors of your site to be asked for a password only once, you chould check the "Ask for a password only once" box in the General Settings configuration window

  • Referrer check

    • When you check 'Add referrer check' box, the referrer configuration window will open. Here you have to set the scope of URL's allowed to link this page, and where to redirect the visitors in case the page is linked from another place.
    Redirection options are:
    Display blank page - will display a blank page.
    Redirect to this URL - here you can enter any valid URL like http://www.protware.com - visitor will be redirected to this url in case the referrer is outside the scope of URL's allowed to link this page.
    Let's explain what referrer is - this is information about where you come from. Let's say you have two pages, page1.htm and page2.htm    , and you have a link to page2.htm in page1.htm. When you click the link in page1.htm and open page2.htm, the browser will know that you come here from page1.htm. Actually, the referrer would be http://www.yourdomain.com/page1.htm.
    But if you open page1.htm and then you visit page2.htm, but not by clicking a link to it (like if you type the page2 url in the url field of your browser, or if you open page2 from your bookmarks), the referrer will be an empty string.
    So the referrer check option is useful if you don't want your pages to be linked from another websites.
    In 'This page can be linked from' textbox you have to enter some common part from the URL's of the files allowed to link this page. Normally that would be your domain name, like protware or protware.com - in this case the protected file can be linked only from within your domain. You may also include a filename here, like http://www.protware.com/features.htm, or just protware.com/features.htm - in this case, the protected file can be linked from the specified file only.
    To say it in another way - the protected file can be linked only from files which URL's contain the string you entered in 'This page can be linked from' textbox. If for example you enter there 'com', the file can be linked from any other file from any whatever.com domain, or from communications.org
    Note: This option will not work for files opened in javascript generated windows. For example, the referrer check will fail for the protected file test.htm if you open it from a script like this
    new_win = window.open("test.htm");
    , no matter from which file you open it. This option will work only for files opened by clicking regular hyperlinks like
    <a href='test.htm'>Click here to open test.htm</a>
    Note: This option will not work offline. If you test a file protected with this option offline, the referrer check will always fail and the action specified in case of an incorrect referrer will be performed (you'll be either redirected to the URL specified in case of an incorrect referrer, or a blank page will be displayed - depending on what you specified in the referrer check configuration window).
    Never use this option when you protect files intended for offline usage, like for example tutorials in HTML format that will be distributed on CD's etc.

  • Disable page printing

    • Checking this option will make impossible a protected html file to be printed.
    This option may not work for some Netscape 4.x versions. If you want to deny access for Netscape 4.x browsers to your site, read this.
    Note: This will not actually 'disable' printing. If someone tries to print a protected html file, only blank pages will be printed.

  • Disable Clipboard & Print Screen

    • This will only work in IE 5+ browsers. If this option is checked, this will totally disable the clipboard and the ability to take screenshots by using the Print Screen button. The clipboard will be fully disabled while a page encrypted with this option is opened - it will be impossible to copy/paste text, files or anything else.
    If your site uses frames and two or more html files are displayed in the frameset, it is recommended to use this option for only one of the files.

  • Encrypt Meta tags

    • HTML Guardian is designed to skip Meta tags when encrypts html files, because in most cases there is no need to do that. Also, some Meta tags may have no effect if encrypted(such as content, keywords, or the ones that define the character set). But some meta Meta tags will work fine encrypted, for example refresh.
    If you use this option, all Meta tags will be encrypted.
    If you want to encrypt only some of the Meta tags: Cut the Meta tags you don't want to encrypt and leave the ones you want. Check 'Encrypt Meta tags' and encrypt the file, then paste the unencrypted ones in the beginning of the head tag of the encrypted file.

  • Only compress code(without encryption)

    • There could be some files you don't want to encrypt. You can use this option to decrease their size. It will remove all unneeded characters from the html code, like new lines, tabs, spaces, comments etc. Compressed files can be edited with HTML editors, but it will be inconvenient(although possible) to edit them with a simple text editor such as Notepad. The results of compression may vary a lot, file size can be decreased from 3 to about 30 %.
    This option can't be used for vbs or asp files, and all additional protection options are not available.
    HTML Guardian offers two code compression levels - High and Low. Files will be compressed with the currently selected compression level, which can be changed from the General Settings window.
    Note: You don't have to compress files first and then encrypt them. HTML Guardian automatically compresses the files before encryption.
    Note: In HTML Guardian Personal edition the "only compress code" option is limited to files up to 8-10 KB in size. Larger files will be compressed only using the Low compression level. This limitation will not be applied for the files you encrypt - they will always be compressed using the level specified by you.

  • Disable syntax check

    • HTML Guardian displays a warning if the file being encrypted is with an incorrect syntax. If you use this option, warnings will not be displayed. HTML Guardian's syntax checker will still work and will create a new entry in the Error Log for each error detected.
    In many cases the files listed in the error log will work, but there is no guarantee.
    You should check all encrypted files listed in the error log - if they do not work as expected, you should check and fix the original files, then re-encrypt them.
  • Using HTML Guardian's Auto Update utility

    • To check if a new version of HTML Guardian is available, click 'Check for updates' under the 'Update' menu.
    This will start HTML Guardian's Auto Update utility which will inform you whether a version newer than the one you have is available. In case there is a newer version, you can read a brief description of the new features added, then the updates will be downloaded and installed automatically.
    The Auto Update utility will detect all information needed to connect to the web (proxies, DNS, etc.) from your default browser, you don't have to configure it. But you have to be connected to the internet before starting it, otherwise an error message will be displayed.
    Auto Update utility is only available in HTML Guardian Professional / Enterprise Edition.


Ultra - Strong Password Protection

Ultra strong password protection is a new feature in HTML Guardian which allows html files to be password protected in an extremely secure way.
The cipher algorithm used allows files to be protected with a strength corresponding to a 384 bit key(maximum) - this is billions times stronger than the 128 bit encryption used in today's browsers (128 bit encryption is considered secure enough for online credit card payments and other transfers of sensitive information).
HTML Guardian is the only tool to provide such ultra strong encryption (although many programs provide pseudo - secure protection based on elementary algorithms).

You can open the ultra strong password protection window from the Tools menu, from the ToolBar or by pressing CTRL + U.
Note: Ultra strong password protection is fully functional only in HTML Guardian Enterprise edition. In Personal and Professional editions you can use it only for small html files which does not contain links and scripts.
A complete comparison between HTML Guardian Personal, Professional and Enterprise editions you can see here.

  • Advantages and disadvantages of ultra strong protection
  • Usage
  • How secure is this protection?
  • Editing the template
  • Can I manage multiple users and passwords with the Ultra Strong Password Protection utility?
    I want to have an individual password for each user.
Advantages and disadvantages of ultra strong protection

There are two main advantages:

- Nobody can never ever view the content of the protected file without providing the correct password.
If you use a strong password, it's impossible to crack the protection no matter what method is used to crack it ( linear or differential cryptanalysis, brute force cracking etc - please read the "How secure is this protection" section below).

- The person(s) to view the encrypted content don't need any special software, just a javascript enabled browser. Usually to view some encrypted content, you must have the same software used to encrypt it. This is a big problem since most people usually don't know how to work with this sort of programs, where to find them, and in many cases they are expensive, or a subject of export restrictions.
If you use HTML Guardian's Ultra strong protection, everybody can see the protected content in a browser if he/she knows the correct password. You can encrypt some file and send it as an email attachment, or just put it somewhere on the web - nobody can ever view the protected content without the correct password.

Disadvantages:
- The disadvantage of the ultra strong protection is that it increases the size of the protected file more than twice, plus about 16K for the decryption code. However with today's speeds this is not actually a problem, even for the disappearing minority of phone modem users.

- Image Guardian can not be used for ultra-strong protected files.

Ultra strong protection is not intended to protect your source code from theft but to protect a highly sensitive information in an extremely secure way. If you trust somebody enough to give him/her the password to view the protected information, you will not expect them to steal your source code. However almost all HTML Guardian's source code protection options (like disable right click, text selection, printing etc) can be applied to ultra strong protected files - please read the "Editing the template" section below for information about how to do that.

Usage
To encrypt a single file, click "Select File" button. To encrypt multiple files at once drag them from Windows Explorer and drop them into the big textbox in the Ultra-Strong protection window.
Usage is quite simple - you have to configure the following:
Where to store the decryption code - it can be stored either in an external .js file named se.js, or inside the protected file itself. The first method is better if you want to protect multiple files (even with different passwords) - in this case the decryption code needs to be downloaded only once. Second method is better if you want to encrypt a single file, like a file to send as an email attachment.
How to prompt the user for a password - the password can be entered either in a javascript prompt box or in a password field in the html file. The first method is simple and will work for all javascript enabled browsers. The password can be viewed when typed. Second method will only work for IE5 and later , Netscape6 and later and Opera7 and later - it will not work for IE4, Opera 3.x - 6.x and Netscape 4.x. In this case the password can't be viewed when typed, and what your visitors will see before entering the password can be customized (read "Editing the template" section below).
Password length must be between 6-48 characters. Acceptable characters are:
a-z A-Z 0-9 ~ ` @ # $ % ^ & * ( ) _ - + | [] { } : ; ? < , . /
Empty spaces can be used as well, but not as a first character.
You can also use many special characters like
£ € ¥ © ® ™ Ø æ ‰ † ‡ and about 50 other characters of this sort. They are usually entered by holding the ALT key and typing a 4 number sequence. You can also use non-english letters but you have to be sure the person that will type the password can enter them so it's not recommended. You should NOT use single ' or double " quotes in passwords. Passwords are CaSe SeNsItIvE.
Save behavior - you should configure this only if you selected to encrypt multiple files at once.
If "Backup & Overwrite" option is selected, each file will be overwritten with its encrypted version and a backup will be created. If "\SE subfolder" option is selected, the file will be saved under its original name in a \SE subfolder (it will be automatically created) of the folder where it resides. An example:
Let's say you want to ultra-strong protect the C:\Test\myTest.htm file
If "Backup & Overwrite" option is selected, the encrypted file will be saved as C:\Test\myTest.htm. The original file will be backed up as C:\Test\myTest.htm.bak
If "\SE subfolder" option is selected, the encrypted file will be saved as C:\Test\SE\myTest.htm. The original file will remain unmodified.
Note that if you select "\SE subfolder" option any external files referenced in the protected file(like images etc) will not be available in the \SE subfolder when you test the file - you have to copy them there for the file to work as the original.
Note: This option has absolutely no effect when you encrypt a single file selected with the "Select File" button. In this case where to save the encrypted file is determined by you after clicking the "Save" button.
Ask for a password only once - this is a very useful option. You may want to ultra-strong encrypt many files, but it will be annoying for the visitors of your site to enter the password for each of them. If this option is selected, the users will have to enter the password only once (the first time they try to open any ultra-strong protected file). All ultra-strong protected files they want to see afterwards will not ask for a password but will be decrypted using the password entered for the first file.
You can't use different passwords if this option is used. A file encrypted with a different password will only display garbage characters.
This option will not work for files opened in a new window - for such files users will be prompted for a password always.
This option can't be used in the Personal or Professional editions.
Note: If you use this option, the password will not be stored on the user's harddisk or on any other place. The user has to re-enter the password each time he/she re-visits your site.

Some notes:
- If the decryption code is stored in an external .js file (se.js) , this file should be available in the same folder where the protected file is. If there are protected files in different folders, you should either put se.js in each of those folders, or(better) to modify the <script src='se.js'> tag to point to the actual location of se.js (this tag is at the very beginning of the protected file).
- You can only encrypt single files. Ultra strong protection can't be used in any of the batch encryption modes. If you specify a password to be used when you encrypt a folder, filelist or a site, the basic password protection will be applied.
- It is possible to use most of the HTML Guardian's source code protection options (like disable right click, text selection, printing etc) in ultra strong protected files - please read the "Editing the template" section below for information about how to do that.

How secure is this protection?
Ultra strong protection uses our javascript implementation of the Blowfish encryption algorithm. It is known to be extremely secure, has no known weaknesses, and is immune to all known forms of cryptanalysis. It is being examined since 1993 (the year it was created) and no method to crack this protection has been found so far.
The original Blowfish algorithm accepts variable-length keys, from 32 bits to 448 bits. HTML Guardian's implementation accepts 48 to 384 bit keys. Using keys longer than 384 bits is impractical, actually using keys longer than 256 bit ensures that nobody, even governmental agencies, will be able to see the protected content.
The only way to crack this protection is by performing the so called brute-force or dictionary attacks.
Brute-force attack simply means trying all possible keys until finding the right one. Hence the more possible keys there are, the longer it takes to try them all (statistically the key is likely to be found after trying about the half of all possible keys). Increasing the password length exponentially increases the number of possible passwords - and the time needed to test all of them. So longer password = better protection !

Let's see some examples:
The number of all possible passwords for a given password length can be calculated with the simple formula
n = NL where:
n is the number of all possible passwords
N is the number of characters which can be used in the password
L is the password length

In our case N can vary, but let's say we will use only a-z, A-Z, 0-9 and a reduced set of 26 special characters mentioned in the previous section. So N will be 26+26+10+26 = 88. For a password length of six characters, all possible passwords to try will be 886 = 464 404 086 784, or more than 464 billion. If we have a computer that can test 1 000 000 (one million) passwords per second, it will need 464 404 seconds, or about 130 hours to test all possible passwords. As we said it is likely to find the password after trying half of the possibilities, or after approx. 65 hours.
Of course the above assumes we can test 1 000 000 passwords per second, which can't be achieved in practice. As an additional security measure, the protected file will not display alerts or whatever if the password was incorrect - it will decode the protected content in all cases, just if the password was incorrect the result will be a bunch of garbage characters. So the cracking computer must spend some extra time to evaluate the result after each password tested.

Now let's see what happens if we increase the password length:

Password length [characters] | Number of possible passwords | Time needed to test all passwords at rate 1 000 000 passwords per second | Time needed to test all passwords at rate 1 000 000 000 000 passwords per second
7 | 40867559636992 | 1.3 years | 41 seconds
8 | 3.59 x 1015 | 114 years | 1 hour
10 | 2.78 x 1019 | 883120 years | 332 days
15 | 1.47 x 1029 | 4.66 x 1015 years | 4 660 510 334 years
25 | 4.09 x 1048 | 1.29 x 1035 years | 1.29 x 1029 years
48 | 2.16 x 1093 | 6.86 x 1079 years | 6.86 x 1073 years

The cracking rate of 1 000 000 000 000 tested passwords per second in the last column definitely belongs to the science fiction, but it can be achieved in the next 10-15 years by using hundreds of supercomputers for distributed password cracking.
The above table clearly shows how increasing the password length increases the security, it's up to you to decide what passwords to use.
Looking at the above values you may think a 15-20 characters password can never be cracked - but this is true only in some cases - only if you use a strong password!!!.
Most people use simple passwords like their pets names, date of birth etc. A password like "Santa Claus is back in town" may look extremely secure (that's 27 characters!!!) but in fact it may be cracked in a few days by using a dictionary attack. This is testing the password against a list of words, for example the entire English(or some other language) dictionary. There are very sophisticated dictionary attack algorithms which can test not only the words in the list but also many combinations derived from them. Like if the word "dog" is in the list, the cracking program will also try god(word reversed) dogdog, ddoogg, ggoodd, gdo, d o g, d_o_g etc. Most programs will also try combinations between words in the list, replacement of letters with numbers that look or sound alike( like d0g), character sequences in the order keys appear on the keyboard(like qwertyuiop or qazwsxedc) etc.

Password cracking attempts usually start with a dictionary attack because it's much faster than anything else and the chances to discover a weak password are good. Then a cryptanalysis is performed. If the encryption algorithm used has weaknesses, it can be relatively easily cracked by using sophisticated cryptanalysis techniques. The Ultra - Strong protection will resist all known cryptanalysis techniques. If the dictionary attack and cryptanalysis fail, the only alternative is the brute force attack which has no chances against the Ultra - Strong protection.

In conclusion:
Ultra - Strong protection can only be cracked by a dictionary attack. So it's up to you to use a strong password which can't be discovered by a dictionary attack - the password should not be derived from a word or a phrase. It should contain randomly mixed upper and lower case letters, numbers and special characters. A password like "Q#H3s d$f" is much better than "Santa Claus is back in town".

Editing the template
As noted above, the ultra strong protection is not intended to protect the source code but to protect a highly sensitive information stored in html format in an extremely secure way. However most of the source code protection options can be used for ultra strong protected files.
HTML Guardian uses a template file named se_template.htm (it's in program's installation folder) for ultra strong password protection. By modifying this file, you can:
- use some of the source code protection options for ultra strong protected files
- customize the layout of the page people will see before entering the password
The template has the following structure:

<script>
.. information about source code protection options to be used
</script>
<body>
.. here you can put your custom code which will be displayed before entering the password
</body>

To modify the source code protection options:
In the <script> ... </script> section of the template, there are six lines that look like
use_disableRightClick=0;
.....................................
Each line defines whether certain protection option should be used. By default all are disabled. To enable some option change 0 to 1. For example if the first of those lines looks like
use_disableRightClick=0;
the right click will not be disabled. If you change it like
use_disableRightClick=1;
it will be disabled.
Lines that start with // are comments - do not touch them
Protection options not listed in the template can't be used.
In the <script> ... </script> section of the template, you can only change some value from 0 to 1 and vice-versa to define whether certain option should be used. Do not modify anything else.

To modify the way protected file looks before entering the password:
You can customize the page people will see before entering the password by modifying the
<body> .... </body> section of the template.
This will only have effect if the user is prompted for password with a password box in the protected file. If you have configured HTML Guardian to use a javascript prompt for entering the password, any changes you make in the <body> .... </body> section of the template will have no effect.
You can add your own code in the body tag, for example to instruct users how to obtain a password, what to do in case of a forgotten password etc. You can also modify the page background colour, insert a background image etc.
Do not put any custom code outside the <body> .... </body> section of the template.
Please backup the template before making whatever changes.

Can I manage multiple users and passwords with the Ultra Strong Password Protection utility?
I want to have an individual password for each user.

No, this is not possible. Any program that claims it can protect a file so that it can be decrypted by providing different usernames & passwords is a home-made "protection" which can be cracked in minutes and should be avoided.
There is no a serious encryption algorithm known that can encrypt a file so that it can be decrypted by using more than one password.
If you come across a program that claims it can protect your data by using an individual user login & password combination for each user, DELETE IT ***IMMEDIATELY*** FROM YOUR HARDDISK AND ***NEVER*** EVER USE IT !!!. If you want to have an individual password for each user, the only option is to use some server-side technology.


HTML Guardian Help

What is HTML Guardian?

HTML Guardian is the first and most popular solution for total website protection. Actually we can say that HTML Guardian is the de facto world standard for protection of web content.

You know how much time, effort, knowledge and experience(or money) is needed to create a professional-looking website. You may spend weeks to create state-of-the-art page layouts and dhtml effects, or to develop and debug sophisticated scripts or java applets. But the result of all your effort can be simply taken and reused by anyone - in today's highly competitive environment, this is something serious web developers would like to prevent.

Most software developers would never reveal their source code, but web developers can't protect their work, it's simply available for everyone. That's why in 1997 we released Web-Cypher!, the HTML Guardian predecessor.

So start using HTML Guardian now and enjoy these great benefits!

  • Total protection for your website !
  • Encrypt your html code and javascripts. Make it impossible to reuse them.
  • Encrypt pages that use server-side includes(.shtml) and .asp files.
  • Protect the images on your website with Image Guardian.
    •
  • No Censorship! Keep away all web content filters. This can increase the average number of visits to your site by several times!
  • Ultra - Strong password protection.
  • Encrypt HTML formatted email.
  • Do not allow stealing of your links.
  • Stop email spiders and avoid spamming.
  • Keep site rippers away from your site.
  • and much, much more ...